-----------------------------------------------------------------------------------------
Data Crow version 4.2.2 - Maintenance                              Released on 2017-08-23
-----------------------------------------------------------------------------------------

[Fixed]
- File Importer did not always find a correct match when using an online service.
  The match checker has been improved. 

[Changed]
- Updated most of the libraries to the latest version.
- Updated the database engine (HSQLDB) to version 2.4 (from 2.3.4)


-----------------------------------------------------------------------------------------
Data Crow version 4.2.1 - From ruin to riches                      Released on 2017-06-27
-----------------------------------------------------------------------------------------

[Fixed]
- Normal users could not log into Data Crow when starting the Data Crow server client.
- The installer did not run "As Administrator" in Windows, causing the Program Files
  folder to not be accessible to the installer. Made an investment in a new executable
  builder which does support running in elevated mode (automatically).
- Imdb.com search was broken. This was mainly caused by the free API turning private.
  I have opted in for the amount of 10 USD a month to keep this service alive 
  (http://www.omdbapi.com).

[Changed]
- Polish translation has been updated. The translation was done by Ariel Chylek, many
  thanks! 
- OFDB.de has been removed. It was in shambles and was not based on an actual API, 
  something which is a bit of a "no no" in terms of both stability and reliability.
- Removed TheGamesDB, their API is still down unfortunately. I have switched 
  this service off for now, hoping to be able to enable it again when it's back.
 
 
-----------------------------------------------------------------------------------------
Data Crow version 4.2.0 - Revitalizing patch                       Released on 2017-02-18
-----------------------------------------------------------------------------------------

[Fixed]
- Navigation to external references is no longer allowed.
- The server operated in local mode for displaying images. To avoid this, and to keep
  things simple, you now have to supply the IP address used on startup of the server
  (-ip:<IP address>). This allows you to specify whether to use the public IP address
  (or not).
- Newly created users were not able to log on. This was only the case if no changes
  were made to the permissions of the user. Newly created users can now always log on,
  regardless of changes made.
- When -dir: parameter was given to Data Crow and the path contained a space, the 
  installation folder is incorrectly determined.
- Network client did not correctly check for empty required fields. 
  The server would fail to save the item, but would fail to notify the client of this
  fact. On restart, the item (not saved) has disappeared from the view.
- Web UI: same item details shown for different items when navigating between pages
  in the paginator.
- Web UI: cannot log on with newly created non-administrator user.
- Web UI: not returned to login page when directly navigating to index.xhtml. No
  data is loaded which is good, but an HTML error is displayed.
- Imdb.com searches: missing images in search results.
- Imdb.com searches: year parsing errors, for some records.
- Moviemeter.nl: was broken completed, reactivated.
- Amazon.com: access key has been changed for security reasons. After applying additional
  security to the Amazon.com account, the service for previous versions of Data Crow
  became unavailable. With this patch, the service has been restored.
- Amazon search has not been throttled to 1 item every second to avoid flooding
  the service with request. 
- Tab order for the item form was not loaded correctly, causing the setting to be lost
  after restarting Data Crow.
- The Quick Search did not work when including %, - or ' in the search string.
- File URLs in the quick view will now work correctly.

[Removed]
- Metacritic.com online search. The search plugin was too error prone and can no 
  longer be maintained. This service has been removed.
- MobyGames online search has been disabled. Awaiting new implementation based on their
  API as currently provided.

[Changed]
- Web UI has been improved. The item overview has been changed to a card like 
  overview and the item form has also been improved. Many other small improvements have
  been made for you to check out.
- The online search has been set to only retrieve up to a maximum of 20 items 
  at a time.
- Increased the input size for the Drive Mappings field from 10 to 50.
  
 [New]
 - Polish translation has been added. 
 
 [Known issues]
 - The GamesDB service is currently offline due to server issues. Service operation 
   will be restored soon, after which this online service should be working again.
   (reference: https://www.facebook.com/thegamesdb).
 - Amazon service can still be flooded with requests when Data Crow is used by 
   many users at the same time. This service should be re-implemented to use batching
   of item lookups. Awaiting to see if the throttling actually helps first.


-----------------------------------------------------------------------------------------
Data Crow version 4.1.1 - Revival patch                            Released on 2016-06-16
-----------------------------------------------------------------------------------------
After a long period of silence, Data Crow rises again to the surface. This patch updates
the external libraries and fixes the most urgent problems. Luckily 4.1 has proven to be 
very stable indeed. It's time to continue onwards to version 4.2.

[Fixed]
- Upgrade process; saving icons to disk was only triggered when upgrading from version 
  4.0.16 or older. This step will be redone with this version.
- Password could not be changed after setting it for a user.
- For both the server and the client, a different database (as supplied with -db:) could 
  not be used.
- For reports the images are now scaled to allow for a maximum dimension of 200x200.
  This to reduce the size of the images and subsequently the report as generated.
- Quick search doesn't work when a quote is in the search value.
- Editing a item "as new" disallows deleting images.
- Play length (duration) incorrectly displayed in the table view.
- The Metacritics.com online search engine did no longer retrieve the title.
  
[Changed]
- The French translation has been improved. All thanks to eReFBe!
- The Softpedia search engine and the Sourceforge.net search engine have been removed. 
  Unfortunately the implementation no longer holds. Each site update is potentially 
  disruptive to these service since there's no web service to get the information 
  reliably and in a structured manner.

[Library Updates]
- PrimeFaces: 5.2 => 6.0
- HSQLDB: 2.3.2 => 2.3.4
- JasperSoft Reports: 5.6.0 => 6.2.2
- JTattoo: 1.6.10 => 1.6.11


-----------------------------------------------------------------------------------------
Data Crow version 4.1 - Crossroads edition                         Released on 2015-07-04
-----------------------------------------------------------------------------------------

[New]
- This version contains the new web server as part of the existing server architecture. 
  This replaces the old web module as was delivered with version 3 but never made it into 
  version 4. The web server delivers the following functionality:
  ~ Searching for items (Search..)
  ~ Creating new item (File > Create New)
  ~ Edit item (Right-Click > Edit)
  ~ Navigation between items (for example, open a software title, then click on it's 
    category, then see which other items have been assigned to this category, etc.). 
  ~ Picking fields for the overview and the item form (web). (Settings > ..)
  ~ Full security model has been implemented
  This web server delivers the same basic functionality (with a tad more style) as the
  old web module and will be expanded upon with each and every normal (4.x) delivery 
  (see the roadmap at http://datacrow.net). 
  Note: this web server is a module of the existing (since 4.0) server edition.
  It allows the server to serve both full (thick) clients as well as web clients at the
  same time. The web server uses an embedded version of Tomcat, version 8.0.23.

[Fixed]
- Change password on a network client caused errors / did not work.
- NullPointerException during start up for users with very limited rights logging onto
  the server.

[Changed]
- MP4 support for Movie File import. Many thanks Lars Kövari!
- The Data Crow Server manual has been updated to reflect the 4.1 changes.


-----------------------------------------------------------------------------------------
Data Crow version 4.0.16                                           Released on 2015-05-28
-----------------------------------------------------------------------------------------
A few feathers were disheveled in the past few months, time to straighten things up!

[New]
- TheGamesDB.net online service has been implemented.
- Credentials for the server can now be supplied through the datacrow.credentials file.
  The Server Manual has been updated to explain this further.

[Fixed]
- Fixed MobyGames.com; Picture import was not working.
- MovieMeter.nl was not updated to use the new API. Re-implemented this service.
- New Item Wizard was closed after notifying an empty field was left empty (loss of data)
- Update All Problems; error when renumbering.
- Update All Problems; check box field value was always applied. Will now only be applied
  if checked / value has been set.
- Update All Problems; with auto numbering enabled, the same value was applied to all.
  Auto numbering fields have been removed from the update all dialog.
- The -userdir: parameter was not checked on it's format; \ or / is now appended 
  if missing.
- Right-click menu for child records (such as Sort, Launch File and Update All) 
  was incorrectly executing the commands against the main record.
- Maintain tabs; on removal of a tab the tabs was still being diplayed in the list.
- Checkboxes, with their initial value, always caused the item to be marked as changed.
- Stop button was not enabled when the Mass Update task was started.

[Changed]
- Updated the Brazilian translation; thanks ever so much Gustavo Rezende!
- Corrected the Portuguese translation; thanks ever so much Pedro!
- The custom label field in the General Field Settings is now represented as an
  editable text field to avoid confusion.
- The Multiplayer? field of the game module has been replaced by two checkbox field
  "Multiplayer Game" and "Cooperative Multiplayer". This removes the Yes/No field.
  For existing installations the field is disabled (not removed).


-----------------------------------------------------------------------------------------
Data Crow version 4.0.15                                           Released on 2015-01-22
-----------------------------------------------------------------------------------------

[Changed]
- Boosted traffic between client<>server. Implemented JSON-IO to limit data send.
- Data Crow Server can now initialize the data folder.
- Server communication has been encrypted (simple encryption, nothing fancy).
- Server communication is now compressed.

[Fixed]
- Older installation can have duplicated module files starting with .#. These will
  now be ignored when starting Data Crow.
- Find & Replace had an error when trying to apply the replacements.


-----------------------------------------------------------------------------------------
Data Crow version 4.0.14                                           Released on 2015-01-13
-----------------------------------------------------------------------------------------

[Changed]
- Data Crow server performance has been improved. Performance is still not optimal but
  has been increased but approximately 25%. Images are now served by Jetty, which will 
  also be used for hosting the web application (version 4.1). Additionally the connection
  between client and server is reused (as it should be) instead of established on each
  request.


-----------------------------------------------------------------------------------------
Data Crow version 4.0.13                                           Released on 2015-01-05
-----------------------------------------------------------------------------------------

[Fixed]
- Issue with online search; images not saved.


-----------------------------------------------------------------------------------------
Data Crow version 4.0.12                                           Released on 2015-01-03
-----------------------------------------------------------------------------------------

[Fixed]
- User fields not visible on the form.
- Conversion from single reference to multi-reference could fail in case of invalid
  entries in the database.

[New]
- Portuguese help files, major thanks to Pedro (pmraps)!


-----------------------------------------------------------------------------------------
Data Crow version 4.0.11                                           Released on 2015-01-01
-----------------------------------------------------------------------------------------

[Fixed]
- Security fix; regardless of the field security settings fields were still shown to 
  users.
- Fixed an issue with non US-ASCII filenames; backup process failed.
- Issue with custom reference fields linked to the music album module. These always 
  showed up as a "Record Label" module.
- Item importer; child items on update of existing items failed. Trying to update an 
  existing music album would not update the music tracks.
- Parent key cannot be NULL exception when trying to save a music album after updating
  it with an online service.
  
[Changed]
- Discogs.com has been removed due to the restrictive authentication flow.


-----------------------------------------------------------------------------------------
Data Crow version 4.0.10                                           Released on 2014-09-02
-----------------------------------------------------------------------------------------

[Fixed]
- Fixed an upgrade issues for the Audio CD and Music Album merge. The error occurred in
  case online services were never used and the columns SERVICE and SERVICEURL were 
  therefore missing. 
- Fixed an upgrade issue for the Audio CD and and Music Album merge. The error occurred
  in case the new tables already exists due to a faulty earlier upgrade or because the
  user installed version 4.0 on top of version 3.12.5. Now, Data Crow will delete
  empty tables required for the new Music Album module. If they contain records, the
  upgrade will fail.
- The module wizard did not handle special characters correctly.
- Tabs containing special characters were not stored and retrieved correctly.


-----------------------------------------------------------------------------------------
Data Crow version 4.0.9                                            Released on 2014-08-27
-----------------------------------------------------------------------------------------

[Fixed]
- Problem resolved for report creation; report not created. Was reported fixed in 
  version 4.0.8 but was still failing for some. The functionality has been tested and 
  has been confirmed to solve the issue.
- After a module has been created and a field has been marked as descriptive the
  view still shows empty labels. 
  
[Changed]
- The upgrade will now silently copy missing reports and translations to the user folder.
  Existing files will no longer be overwritten.
- Added additional report types; Word Document (DOCX), Excel Document (XLSX), 
  Excel Document 97-2003 (XLS).
- Added titles to the various message and question boxes.
- Added nicer descriptions for the report types.
- Added various tool tips for the define field dialog (create module wizard).
  

-----------------------------------------------------------------------------------------
Data Crow version 4.0.8                                            Released on 2014-08-25
-----------------------------------------------------------------------------------------

[Fixed]
- GUID (internal ID) shown for Contact Person in the loan history of the Loan Information
  panel.
- Problem resolved for report creation. This was an old issue which was hard to simulate. 
  An additional check has been added to check whether the file is accessible.
- Not all fields can be added to the Item Report.
- _Persist fields could be selected for the Quick View. 
- Server didn't have the library jacksum added to the class path which caused failures 
  for file hashing.

[Changed]
- The item exported now ignores system fields. Additionally the importer now only tries
  to match an item on import by ID in case the match and merge option has been checked.
- The Create Report manual has been updated.


-----------------------------------------------------------------------------------------
Data Crow version 4.0.7                                            Released on 2014-08-20
-----------------------------------------------------------------------------------------

[New]
- The old reporting engine has been removed. This version now features full support for 
  Jasper Reports (http://community.jaspersoft.com/project/jaspersoft-studio). 
  The main benefits of this switch is that it is no longer required to created 
  separate reports (XLST scripting files) for PDF and HTML reports. The reports
  of JasperReports can be saved as PDF, RTF and HTML. Additionally you can use the free
  Jaspersoft Studio Software to create reports, graphically. This brings a lot more
  power to the reporting capabilities of Data Crow. Data Crow generates the reports 
  on the exported XML files.

[Changed]
- Apache Fop and Avalon Framework (discontinued) have been dropped from this release.
- Icons for message and question boxes have been changed, making use of Java 7 features.

[Fixed]
- Error on startup when the images were supposed to be migrated to the new location.
- NullPointerException when importing files which already are registered in the system.
- Fixed an issue with saving child items.
- Removed defective library which caused image import errors.
- Item Importer bug has been fixed which could caused field values not to be imported
  correctly.
- Still numbering inconsistencies for music tracks.


-----------------------------------------------------------------------------------------
Data Crow version 4.0.6                                            Released on 2014-08-17
-----------------------------------------------------------------------------------------

[Fixed]
- A NullPointerException for the item import has been fixed.
- Potential NullPointerException in case a query fails.
- Logging panel was registered too late in the startup process; missing messages.
- A bug has been fixed where the module importer consumed too much memory. 
  This occurred for larger module exports holding an x number of large images.
  As an added benefit it works now much faster.
- Server startup error; modules could not be loaded.
- Record label list is now sorted by name.
- Fixed an issue where the quick filter bar is shown underneath the toolbar.
  The quick filter is now placed directly on the toolbar itself. The setting
  [toggle quick filter] has now been removed.
- The Drive Manager functionality was broken.
- Resource Editor save issues.
- File Tree panel inconsistencies have been resolved.
- New Item Wizard - pictures not saved for newly saved items.
- Create Multiple Items lacked the option to save.

[Changed]
- The help (F1) has been updated to explain the Quick Search functionality.
- The German translation has been updated; thanks to Ralf Geiss!
- On startup after any upgrade you'll be asked whether you want to use the new 
  translation files.
- File tree panel now shows folder icon for folders which are present on the file system.
- Splash screen was shown quite late in the startup process.


-----------------------------------------------------------------------------------------
Data Crow version 4.0.5                                            Released on 2014-08-15
-----------------------------------------------------------------------------------------

[Fixed]
- Data Crow hangs in case there are unsaved changes in the table view on exiting.
- In rare cases the grouping pane showed zero items while x number of items are present.
- CSV and XML import issues have been fixed.
- Module naming inconsistencies which caused the alter module wizard to fail for 
  various modules, such as the book and container module.
- Items with ID's created before 2006 were not shown anymore in the tree views when
  clicking on a node.
- Behind the scenes, the view was loaded twice on the initial startup.
- Retrieve Audio CD now adds the retrieved CD information to the overview.
- Required field check failure; items were not check upon required fields.

[Changed]
- Record label module; name is now required and checked for uniqueness. Note that
  custom Record Label settings will be reset to accommodate for this minor change.


-----------------------------------------------------------------------------------------
Data Crow version 4.0.4                                            Released on 2014-08-12
-----------------------------------------------------------------------------------------

[Changed]
- Improved Error Handling for recovery. When the database load fails due to 
  inconsistencies Data Crow would in the past just show the user login page. Now, 
  Data Crow will rename the database, show the correct error and close Data Crow.
  On a next start Data Crow is started with a clean new database. The user can now
  restore the last backup. The faulty database does still exists and can be send by email
  to analyze and fix if possible.
- Improved the handling of user folders; 
  You can now switch between user folders without copying the data over from the existing
  folder. The option to copy the data has been made an option from the user folder 
  selection dialog.
- Improved handling of old databases; it was always the idea for users to perform an 
  restore of existing backup in the latest version. Most users however upgrade directly
  which is actually almost enforced by Data Crow. Data Crow will now warn the user in
  case the old database requires a different upgrade path, such as first upgrading to 
  version 3.12.5. Data Crow will not allow the user to continue to avoid database 
  corruption.
- Quick filter is now a search all field; it will search for text and numbers in all
  applicable and search enabled fields at once. On the quick filter bar I have now also 
  placed an icon to quickly open the advanced filter dialog. With this change the 
  quick filter bar is simpler to use whereas the advanced filter dialog can be used to
  create filters of a high complexity (and remember, these can be saved for re-use).
  Note; it is not possible to use regex expressions in the quick filter (not supported
  by the underlying HSQL database). 
- Added Find & Replace to the Filter menu.
- Upgraded HSQLDB (http://hsqldb.org/) to the latest version (2.3.2).
- Added a "Create Support Package" menu item to the help menu. Creates a zip file
  containing all files needed for identifying and resolving problems.

[Fixed]
- Find and Replace was not working correctly.
- Open Item from the right-click menu did not work.
- Fixed an issue in the Database Editor; first column was not shown in the query results.


-----------------------------------------------------------------------------------------
Data Crow version 4.0.3                                            Released on 2014-08-06
-----------------------------------------------------------------------------------------
A small but important bug fix was required. The bug causes a startup error, introduced by
the 4.0.2 version released yesterday. Fixed 2 additional upgrade issues which occurred 
for some users.

[Fixed]
- Error message; full control needed for the install directory. This message was 
  intended for the server installation only. The client doesn't need this anymore with 
  this version.
- Upgrade error in case the old images folder contains sub-directories.
- Fixed an error for the Audio CD and the Music Album merge.
 

-----------------------------------------------------------------------------------------
Data Crow version 4.0.2                                            Released on 2014-08-05
-----------------------------------------------------------------------------------------
IMPORTANT: as of version 4.0.2 Java 7 or higher is required. 

[Fixed]
- Performance issue for network clients has been fixed.
- No message box in case of a warning when deleting or saving an item (only message
  in the log file).
- New Item Wizard did not close after saving and view was not updated.
- Right-click in view, create report, added all items instead of the selected items.
- Error when creating report, invalid path for fonts, report was created though.
  An empty fonts folder will now be created by the installer.
- CSV import was no longer available.
- NullPointerException after entering wrong username / password.
- A faulty library has been removed. The library caused issues with the tree panels 
  such as incorrect item counts or even preventing loading the items at all.
- Server could not run headless.
- Create multiple for music tracks did not show the track number field.
- Create multiple for music tracks; NullPointerException when adding tracks.
- Custom modules were not loaded.
- Patch applied for #625, thanks (StringUtils.normalize2; invalid characters)

[Changed]
- Server no longer requires the file importers, synchronizers and online services to 
  be present (architectural change).
- TrueZip upgraded to the latest version (from 7.7.1 to 7.7.6).
- Image sizes have been increased as well as the quality of the thumbnails. Storage
  size will increase by approximately 20% due to this change.
- The wwwroot folder will be removed from the user folder. You might be asked to remove 
  it manually in case it was not fully successful.
- Additional error handling for faulty modules.
- Changed the font size and color for the help files for better reading.
- Upgrade of the metadata-extractor library to the latest version.
  https://drewnoakes.com/code/exif/


-----------------------------------------------------------------------------------------
Data Crow version 4.0.1                                            Released on 2014-07-25
-----------------------------------------------------------------------------------------
This version can be safely installed on top the 4.0 version. Do not install this version
in the same directory as an older version (3.12.5 and eralier); install this version 
into another directory.

[Fixed]
- Better error handling in case of duplication in the mapping tables for the upgrade.
- Performance bug in the quick view has been fixed.
- Query Panel did not show error messages
- Properties overview did not refresh after deleting an item.
- User mode was not applied, only after a restart.
- Errors due to existing module upgrade files. I have implemented fail safes to make sure
  these are skipped and Data Crow is started.
  
[Changed]
- On upgrading the Audio CD's are merged into the Music Album module. I have now assigned
  storage medium 'Audio CD' to these merged Audio CD's.


-----------------------------------------------------------------------------------------
Data Crow version 4.0                                              Released on 2014-07-23
-----------------------------------------------------------------------------------------

This is a new major release. DO NOT install this version in the same location as
the old version as this will cause the program to fail to start. 

NOTE 1 I have found that in old installations it is possible that both books.jar and a
       book.jar file exists within the modules folder. Remove the books.jar file as the
       book.jar file is the actual file used for saving module wizard changes.
       
NOTE 2 All modifications made to the Music Album and the Audio CD modules will be 
       undone by the upgrade. There was no other way to get the Music Album and 
       Audio CD modules merged.
       
NOTE 3 The web version is scheduled for version 4.1 and is not part of the 4.0 version.

[New]
- Client-Server mode. Full stand alone application server is now available. See Client-
  Server notes for more details. This has been achieved through a complete change of the 
  Data Crow architecture.

[Changed]
! The Audio CD module and the Music Album module have been merged together. It did no 
  longer make sense to have them as separate modules. There is no loss of functionality.
- Italian translation has been updated. Big thanks to Marco Artioli!
- Added additional file support to the movie file import.
- Changed the tabs saving mechanism. Tabs are also no longer stored in the database but
  our now saved per client. This makes it possible for users to create their own form 
  design.
- Code re-structuring; making the code and architecture future proof. This was a huge
  undertaking but will not be directly visible to you as a user apart from having 
  new features released in the (near) future which would not have been possible otherwise.
- Upgraded Apache Tika to version 1.5
- Added a column selector to table views (right-click on the table header).
- The discogs.com music search has been implemented using the official API, making it more 
  reliable and future proof. 
- Added Record Label to the the Music Album Module.
- The Sourceforge.net online service has been rewritten to use the official API, making it 
  more reliable and future proof. 
- JTattoo (Look and Feel manager) has been upgraded to version 1.6.10.
- You can now place true type fonts (TTF files) in the fonts directory of the install
  folder. These will be loaded by Data Crow and can then be used. They will appear at 
  the bottom of any of the font selection lists.
- PDF reports now can make use of Fonts installed (copied) to the fonts folder of the
  Data Crow installation folder.
- Additional settings can be done by the user by editing the "pdf_config.xml" file
  as located in the reports folder (of the user directory). Instructions:
  https://xmlgraphics.apache.org/fop/1.0/configuration.html
- Updated the Module Creation Guide (http://www.datacrow.net/#downloads)
- Updated the Create Report Guide (http://www.datacrow.net/#downloads)
- Created a Client-Server Guide (http://www.datacrow.net/#downloads)

[Fixed]
- One more small issue fixed when upgrading from an old version of Data Crow.
- Regex pattern for the file importer was applied after changes to the name were applied 
  by Data Crow logic. This can cause the regex pattern to no longer match. The regex
  pattern will now always be applied first.
- Lent versus lend grammar mistakes.
- Avoiding null pointer exceptions in case fields no longer exists.
- Restart of the Delete Module Wizard started the Create Module Wizard
- Problems with the creation of modules due to invalid table names caused by special
  characters. Now the names are auto generated.
- UTF8 problems with the module.XML files has been resolved.
- Issue with user creation. Module permissions were not saved correctly on the user 
  creation. It only worked after updating the user.
- Create multiple used the view type (table / card) based on the selected search view.
  Because of this the card view was used sometimes which is not editable.
- Backup process reported missing "dc.lck" and "dc.log" files.
- Opening the form to create a new user took a long time. 
- Module wizard creation module allows Picture fields to be added to property modules
  while this is not supported. Option has now been removed.
- The Mobygames.com online search has been fixed.
- The Sourceforge.net online search has been fixed.
- Dictionary.txt was saved in plain text instead of in UTF8 format.
- Original label in the general field settings showed the new, custom, label after 
  the user made the translation.
- The view and quick view were not updated after performing a loan action (return / lend). 
- Mismatch between the contact person module name and the module jar file.
- A white space for decimal grouping symbol is reset to "." after a restart.
- Drive Manager window settings not applied correctly.

[Client-Server Notes]
A manual has been released: http://www.datacrow.net/#downloads

Highlights:
* Clients don't have access to restore and backup functionality, regardless of their
  access rights. These options are solely available when running Data Crow directly on
  the server. Future versions might have scheduled backup routines.
* Server can be started using the server command. It's a headless server, meaning it 
  doesn't require a monitor / has not GUI.
* Clients are thick clients. Wait for the new web GUI release for thin client access.
  Note that Data Crow will always support the client-server mode as currently released.
  The code has been optimized for client-server access. Data is pulled in small batches.
  For example, when scrolling in the table and list view only does items
  are fully retrieved from the server which are currently visible. Clients connected to
  a server will however always be slower than standalone clients.
* User management is available directly and has remained unchanged from previous
  version. You can indicate on field level if the user has access to it and what he/she
  can do with the field content (read/update/delete).
* Icons are cached on each client. No synchronization on icon changes has yet been 
  implemented. Nothing else is cached on the clients. After a restart of a client
  the icons are retrieved from the server.
* The clients retrieve the settings, modules and value enhancers from the server.
  Not all settings can be done on the client due to security restraints.
* Modules, system settings and value enhancers are downloaded from the server on startup,
  this way the server is in control for the modules and system wide settings.


-----------------------------------------------------------------------------------------
Data Crow version 3.12.5                                           Released on 2013-10-09
-----------------------------------------------------------------------------------------
"Too many versions!!!" - "You do not have to upgrade" ;-)

[Fixed]
- Ratings again shown as boxes in the quick view. Fixed - for now and ever.
- File Importer issues fixed where items were not added to the view (but became visible
  after a restart). Rare occurrence.
- Module settings for Software table view caused columns to show multiple times. Default
  setting has been fixed.
- Deletion no longer allowed from Media module. Enabling this would cause deletion in
  general to go a lot slower.
- Category was no longer processed correctly for the Softpedia online search.

[Changed]
- After an import the view will now always refresh instead of adding the items one by 
  one immediately after they have been processed. This improves speed and just works a
  better.
- Removed setting "Add directly" from file import; Data Crow will now always add items
  directly.
  

-----------------------------------------------------------------------------------------
Data Crow version 3.12.4                                           Released on 2013-10-06
-----------------------------------------------------------------------------------------

[Fixed]
- Error in the "Copy Module Wizard".
- Ratings not displayed (depending on font settings) in the quick view panel.
- Mobygames.com service was not working correctly after update of their site.
- Cannot create new person-modules.
- Upgrade error fixed for older versions.
- Spelling errors (lend/lent)
- CSV item importer could result in errors. 
- IMDB.com service down. Switched to http://www.omdbapi.com for now.

[Changed]
- Rating star images have been changed.
- Added ISBN 10 and ISBN 13 fields to the quick filter.
- The Mobygames.com online search has been rewritten completely.


-----------------------------------------------------------------------------------------
Data Crow version 3.12.3                                           Released on 2013-09-07
-----------------------------------------------------------------------------------------

[Fixed]
- Alter module wizard: change field; maximum length always defaulted to 255.
- Potential issue for Template Name and Default field. These could conflict with the
  normal fields of the module.
- Exported field order is now the same each time.
- Item matching on import is now also done on the "key fields".
  

-----------------------------------------------------------------------------------------
Data Crow version 3.12.2                                           Released on 2013-08-15
-----------------------------------------------------------------------------------------

[Changed]
- Updated German translation: big thanks to Ralf Geiß!
- Template default and name have been moved to the "Template Properties" tab.

[Fixed]
- Changes not saved using the quick filter on resource editor.
- Filter not saved when value is empty.
- Template not applied to items retrieved by the online search.
- Templates overview settings incorrect


-----------------------------------------------------------------------------------------
Data Crow version 3.12.1                                           Released on 2013-08-04
-----------------------------------------------------------------------------------------
A minor release to include additional changes and new functionality. Much needed fixes
for the references fields have finally been included. 

[Fixed]
- Icons for containers not shown in trees, fields and in the quick view.
- Icon for modules disappears in the Media module.
- Error loading setting if value is erroneously empty.

[Changed]
- Merging property items will now also update the "alternative names" field, merging
  items returned from online searches, etc., automatically.
- In the past, due to performance issues, I had refrained from updating trees in case
  a property was changed. This has now been fully implemented; changing an icon will
  immediately be reflected on trees, multi-reference views and the quick view panel.
- Added quick filter to the related items and fixed the sorting.
- Added quick filter for the items tab of containers. Sorting cannot be fixed just yet.
- Several minor layout changes (button alignment) such as for the tool select wizard and
  the update all dialog.
  
[New]
- Added a right-click option for the related items tab of the item form to 
  remove the selected items as a reference.


-----------------------------------------------------------------------------------------
Data Crow version 3.12                                             Released on 2013-08-03
-----------------------------------------------------------------------------------------
Poor version 3.11. It only took a couple of days and then it got replaced by version 3.12.
This really is for the most part a cosmetic edition. I have changed the layout a bit 
further. This is also a preparation for the web GUI since I want to keep the layout for
both the same, for as far as possible. Due to the list of changes made and the addition 
of new functionality I have decided to release this as a normal version instead of a minor 
version.

[New]
- The property items overview (found in the Administration menu) gained a new tool: 
  delete unassigned items. This will remove all properties not assigned to any other item
  For example a category not used in software items will be removed.
- Another new tool for the properties module is the merge functionality.
  Having many categories (for example) which actually have the same meaning? Merge them
  all into one property. All references to the properties will be corrected 
  (without duplication, of course).
- The Resource Editor now has find and replace functionality.

[Changed]
- The screen is now much cleaner and it makes the application look simpler.
- The file associations setting now also allows parameters to be defined.
- New items tab has been removed. 
- Online Search will now directly save the item instead of adding the item to the 
  "new" tab.
- Chart tab has been removed. You can open the new charts dialog from the tools menu
  as well as from the tool bar.
- Create Multiple Items tool has been added (as a replacement for the new items tab).
- Item importer will open the new items dialog to lists the imported items before saving
  them.
- The module bar has been changed. Labels have been removed. Additionally the select 
  module section has been improved. Selecting a sub module will highlight it on the 
  main module panel.
- Improved startup time by building forms on demand instead of on startup (where
  possible) - 4.9 seconds on an almost empty database in 3.12 against 6.0 seconds on
  the same database with version 3.11.1.
- ISBNdb.com has been changed and the information is of limited use now to Data Crow.
  This service has been disabled.
- Help has been updated to reflect all of the above (press F1 once in a while just for
  the sake of using it).
- The Find and Replace utility now also allows you to change one reference with another.
- Update all now refreshed the overview after updating the items (instead of updating 
  one by one). 

[Fixed]
- On startup Data Crow tried to modify files in the installation folder, causing problems
  for Windows platforms. Data Crow can now be launched without administrator permissions.
- Applying settings such as the language change was only properly applied after a restart.
- Sort order of persons has been fixed (always sorts on complete name now, takes care of
  rewritten names).
- Screen parts resized ever so slightly and ever so annoyingly.
- Could not really tell which module was selected.
- Fix for launching files from the Quick View Panel.
- Column order for tables not correctly applied.


-----------------------------------------------------------------------------------------
Data Crow version 3.11.1                                           Released on 2013-07-20
-----------------------------------------------------------------------------------------

[Fixed]
- Logger not initialized error message on prompt / console.
- File launcher fixes (for all platforms).
- Indicated "run as administrator" for the data crow executable and the setup executables
- Column names in the database are no longer allowed to start with a digit. The
  module wizards have been updated accordingly.
- Still a Log4j not initialized message at the command prompt, argh.., fixed forever!
- Imdb.com not working.

[Changed]
- Paths for files linked to items are now handled a bit differently;
  a) if the file is located in the Data Crow installation directory a relative filename
     is used.
  b) if you are using drive mappings across Windows / Linux the backslashes and slashes
     will be corrected as well.
  The original filename is stored unmodified(!)
- the user folder selector now checks for:
  a) existing folder selected, containing files (continue y/n).
  b) moving from one location to another (move files y/n).
  c) root folder not allowed as a Data Crow user folder.
- Readme.txt added for the installer (which setup executable to use..)
- Readme.txt of Data Crow updated.


-----------------------------------------------------------------------------------------
Data Crow 3.11  [Released on July 22 2013]  [testing: moderate]  [target: production]
-----------------------------------------------------------------------------------------

[New]
- iCalendar export for the loan administration (Tools > iCalendar Loan Export)
- New online search (TheMovieDB.org). This online search supports searching for movie
  information in multiple languages.
- Tag words functionality has been added to all top modules. Easily add and remove
  tags to items. Tags are the same across all modules. Auto-completion while typing 
  is supported to re-use existing tags. 

[Fixed]
- Various potential resource leaks have been discovered and fixed.
- Potential errors in video parser have been fixed.
- Changed the backup process to ignore any "non-DataCrow" files.
- Number of pages returned from Google Books was incorrect (103 was shown as 10).
- Setup executable files now available for both the 32bit and the 64bit Java version.
- Issue with the CD reader "Executable name has embedded quote, split the arguments java" 
  has been fixed.

[Changed]
- Added parameter "port:" to specify the port to be used by the web server on start up.
- In case the user folder is cleaned Data Crow will re-initialize the folder.
- Added the option to change the user folder on startup. You can hide this question on 
  next runs. The option is always available from the settings menu.
- For new users only - font size increased from 11 to 12. Note that you can change the
  font and its size yourself from within Settings > Settings > Font.
- Newly supported file types for the file importer are now configured automatically.
- jAudioTagger library update from 2.0 to 2.2.
- Filter error when filtering on the due date from / to in the loan administration.
- Various small improvements to the loan administration panel such as a cancel button
  for the current search action.
- Allow multiple items to be returned from the loan administration overview (right-click,
  select Loan Administration).
- Lending containers will now also lend all its item. Same applies for returning an 
  container. 


-----------------------------------------------------------------------------------------
Data Crow 3.10.2  [Released on July 2 2013]  [testing: moderate]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- 64 bit JRE not detected by executable of Data Crow
- Incorrect Font when saving settings (while not having changed the font settings)
- Issue with web application where read only user only sees ID values for drop downs.
- Issue with extracting ISBN information from PDF files (old libraries updated to current
  versions - thanks Gene!).


-----------------------------------------------------------------------------------------
Data Crow 3.10.1  [Released on May 23 2013]  [testing: moderate]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Image not saved when updated through an online service.
- Saving the field settings for property modules also changes the quick view settings of
  the currently active module
- Table view shows the same column multiple times.
- Mass Update does not save images.


-----------------------------------------------------------------------------------------
Data Crow 3.10  [Released on May 18 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------
Thanks mrpenguin007 for the updated German translation!
See http://sourceforge.net/projects/inventarverwalt/ for the module he has created.

This release mainly focuses on the help file, which has been greatly improved.
During the writing of the help file the discovered issues have been fixed. Small 
improvements to the GUI have been made to improve the experience in using Data Crow.
This is the first release since a long time having a completely up to date help.
Note that the help is still only available in English; translators are very welcome 
to help out.

[Fixed]
- No ShortCut created by the installer for Windows 64bit version.
- The log file is created initially in an incorrect location.
- Create multiple not working for any non music track modules.
- Issue where images are not always imported for items part of the imported main module.
- Container sometimes can't be saved.
- Loan shows incorrect period in case no due date has been set.
- Loan text shows "item is due on null" in case the due date is empty.
- Size of the help screen was not remembered.
- Resizing the settings view caused the application to crash.
- Date operators for the filter were not correct for dates.
- Passwords always needed to be entered in upper case after changing it. Now it
  works correctly, case-sensitive, for NEW passwords. 
- The horizontal setting for the Quick Fields Setting did only work when working in the
  English language.
- Picture not shown on the Data Crow item after starting Data Crow for the very first 
  time on Linux systems.
- "Is Filled" and "Is Empty" operators for filters on multi-reference fields were
  not correct.
- Saving from the web client could go wrong. Fixed. 

[Changed]
- I have made a lot of improvements to the help text (F1). I have added links in there,
  pointing to the detailed help text where necessary, have added a lot of additional 
  information in general, screenshots, etc. This was 24+ hours of work, so you better 
  read all of it!
- Updated the German Translation. See http://sourceforge.net/projects/inventarverwalt/
- Removed the filter operator 'Equal' and 'Not Equal To' for multi-reference fields;
  already covered with contains and does not contain.
- The Item Importer now has a setting to disable the item merging.
- I have added a Settings menu to the property item views. From here you can make changes
  to the item form layout and adjust the field settings. This was the only part of 
  Data Crow where you could not make modifications.
- Better initial settings for the item forms of the property modules.
- Added a filter field to the property maintenance overviews.
- Improvement made for multi-reference fields item selector


-----------------------------------------------------------------------------------------
Data Crow 3.9.26  [Released on May 12, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Fixed an issue with the -userdir: parameter; relatives paths could not be used.
  The setting would always revert back to the installation dir which is not allowed to 
  be used.
- Module Exporter error for exporting items from related modules.
- Module Exporter exports all items assigned to containers. This is faulty since the main
  items are already exported. Container items should not be treated as normal children.
- XSD fix for the Item Export (it was not fully correct).
- Java 7 denies creating backups in the root folder of any drive. I have added a 
  message, preventing the root folder to be selected. Hopefully I find a real fix for this.
  The issue is with TrueZip. They have a newer version but that would force all users to
  start using Java 7, while I still want to support Java 6 as well.

[Changed]
- Added a restart message after the module has been imported successfully.
- When the system is upgraded the system will now also check whether there are new
  reports and/or resource (language) files available in the installation folder. If so, 
  Data Crow will ask if it is okay to copy the files over from the installation folder 
  to the user folder.
- Loan Administration would open very slowly in case you have many loans outstanding.
  Items are now loaded in a separate process and the progress is shown in the 
  progress bar. 
- Same as above, but then also for the lend items tab of the contact person.
- Settings are now stored per client. On startup a Unique ID for your system is generated
  and stored in the datacrow.properties file. The existing system settings are used as 
  a template for these new settings files. This allows multiple client to work in the
  same Data Crow user folder while not being effected by the settings done by other users.
  The module settings are still shared though.
- For Windows systems the default font has been changed to "Arial Unicode MS" for 
  foreign character support. This only applies to new installations.
- The Expert Form has been replaced by the Database Editor tool. This one now only has
  the SQL queries panel.
- The log form has been expanded to include system information (moved from the expert
  form).
- Removed some borders from the main screen.
- Changed some of the default settings, for new users, mostly for colors and the 
  default look and feel.
- Small improvement to the file structure tree panel.


-----------------------------------------------------------------------------------------
Data Crow 3.9.25  [Released on May 10, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- More upgrade errors for old versions have been fixed. This time it's related to old
  columns still being present due to failed upgrades in the past. The upgrade process
  will now actively check for these and correct where necessary.
- Performance bug in the table view.
- Lend items in the loan administration are not shown by title.
- Sometimes the items in the quick view for the container items are not sorted 
  alphabetically. 

[Changed]
- Small change to the module selection panel.


-----------------------------------------------------------------------------------------
Data Crow 3.9.24  [Released on May 9, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- References show without a name, sometimes...
- PDCR error when creating new items (item was created successfully)
- It was possible to create infinite loops in the hierarchical structure of the 
  containers when creating tree structures of 3 levels or deeper.
- NullPointerException when clicking the "New" button from within the container item
  form.
- When adding new children (such as tracks) the view was not always updated correctly.
- Quick view font and font sizes were not fully in line with the settings. Additionally
  the header text is now always 4 points larger as the text font.
- The space between the text and the icon was underlined (quick view and multi-reference
  fields in the item form).
- In the Dutch translation the categories field for Software Items was labeled as license.

[Changed]
- New layout of the main screen.
- Removed the JTattoo border in the menus.
- Removed a few icons from the toolbar.


-----------------------------------------------------------------------------------------
Data Crow 3.9.23  [Released on April 20, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Sourceforge.net search did not work correctly.
- OFDB online search no longer retrieved the genres correctly.
- Templates cannot have image / image not saved.
- Startup error in case default data is present for non existing module.
- When selecting a new user directory through the parameters Data Crow does not set up the
  user folder. This results in you only having access to the user module.
- The directory for upgrade script was not yet transferred to the new user folder. 
  This was no problem for upgrading, however, for new conversion required Data Crow
  could not have any write privileges to these files. 
- Newly added fields (using the Alter Module Wizard) are now enabled by default in the
  general field settings. 

[Changed]
- Imdb.com movie search now uses ImdbApi.org instead of Imdb.com web site parsing.
  Language setting now only applies to the localized title name. All other texts, etc,
  will be retrieved in English. This is a deliberate change as the web parsing is very
  error prone and hard to maintain. Note that you are limited to 3000 searches per hour.
- Items shown for the container module are now sorted alphabetically.


-----------------------------------------------------------------------------------------
Data Crow 3.9.22  [Released on April 29, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Fixed multiple upgrade issues (not being able to log in after upgrade). The system
  will correct problems on startup for failed upgrades or else when newly upgrading.
- A check will be done on startup to correct, if necessary, any inconsistencies in the 
  database.
- Issue with the file importer; resource consumption has been lowered.
- Issue with the file importer; check whether an item already exists has been improved.
- Searching on ISBN for books does not work in case the ISBN contains an X.
- Fixed the CSV import for text containing a double quote character.
- Added checks for the Quick Filter.

[Changed]
- Updated version of the Italian translation from Marco Artioli (thanks!).


-----------------------------------------------------------------------------------------
Data Crow 3.9.21  [Released on February 10, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Minor fixes for the restore process.
- Fix for the HSQL upgrade.
- Ratings from IMDB.com were no longer retrieved.

[Changed]
- Various small optimizations.  
- Updated the German translation - thanks to Norman Weimar
- Prevent users from selecting the installation folder as the user folder. The user 
  folder is and was meant to separate the installation folder from the user folder.
  Mostly because the OS these days add additional security to the installation folders
  not allowing ordinary users to change files. You can still select a folder inside
  off the Data Crow installation folder.
  
  
-----------------------------------------------------------------------------------------
Data Crow 3.9.20  [Released on February 02, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Changed the restore and backup process to support backups larger than 4.28GB with the
  use of TrueZip.


-----------------------------------------------------------------------------------------
Data Crow 3.9.19  [Released on January 18, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Users can now safely upgrade from version 3.8.16 and early; without losing of pictures.
- Small uses during upgrades in general such as an empty log form shown after 3 or more 
  upgrade scripts.
- Title rewriter and name rewriter work again. There was an issue after the upgrade
  of the database engine.

[Changed]
- It is not possible to specify the user directory relative to the Data Crow installation 
  folder. Start the name with a dot (.) to make the path relative to the installation 
  folder; ./data or .\data. This only works for the -userdir: parameter.
- The File Importer now allows the online search to always pick the first result.


-----------------------------------------------------------------------------------------
Data Crow 3.9.18  [Released on January 18, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------
Pfew, the changes I made took quite a number of releases. I hope to have it under control
now. The backup and restore now works correct again. The issue with the upgrade of the 
database not working is mainly a security issue on the various platforms. The only 
solution is, when prompted, to run the command as stated in the message box from the 
command line / command prompt / terminal.

[Fixed]
- Backup and restore ignores custom made modules.


-----------------------------------------------------------------------------------------
Data Crow 3.9.17  [Released on January 12, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Changed]
- Improved module importer

[New]
- Added a parameter "-userdir:" to overwrite the determination of the user directory
  altogether. This allows for running multiple instances of Data Crow looking at 
  separate user directories.

[Fixed]
- Start up errors for new installations of Data Crow.
- Module images not shown on the web due to incorrect path in user directory.


-----------------------------------------------------------------------------------------
Data Crow 3.9.16  [Released on January 11, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[New]
- You can now select a user folder where all data is stored. This helps in avoiding the
  Windows problem of protected folders in the C:\Program Files\ folders as well as 
  protected folders on other systems. On startup you will be asked to select the user 
  folder. After selecting the folder Data Crow will migrate your data to this folder
  and will use this folder from then on.

[Fixed]
- Upgrade error for Linux users.
- Icons not shown in the multi-reference fields.


-----------------------------------------------------------------------------------------
Data Crow 3.9.15  [Released on January 6, 2013]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- In the web client sorting for numbers was incorrect (1,12,2 instead of 1,2,12).
- In the web client information for multi-reference fields was sometimes duplicated.
- Multi-reference fields could not be edited in the web client.
- Remove option in the "New items" tab did not always work.
- Defining a template disrupts the online search functionality.
- Permissions for users incorrectly saved. Currently incorrect permissions will be 
  removed from the system.
- Login name field for persons of an incorrect height.
- Discogs.com has been fixed; images are now retrieved again.
- ArrayOutOfBoundsException when removing all tabs from the item form settings.
- Slow speed for web client for searching.
- Imdb.com not working fully.
- BOL.COM not working at all

[Changed]
- Charts: now also possible to create charts for fields such as author, publisher, etc.
- Templates are no longer allowed to overwrite existing values.
- Changed the layout (default settings) for the user module.

[Upgrades]
- The database has been upgraded to HSQL 2.2.9 (from 1.8). This is not an easy upgrade 
  hence the extra prompt and restart when opening Data Crow.
- Upgraded to the latest version of JTattoo (for the Look and Feel), version from 
  August 2012.
- Upgraded to the latest version of IzPack for the installer.


-----------------------------------------------------------------------------------------
Data Crow 3.9.14  [Released on June 16, 2012]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Reports not working
- Google search sometimes throws a NullPointerException


-----------------------------------------------------------------------------------------
Data Crow 3.9.13  [Released on June 9, 2012]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Known issues]
- The Barnes & Nobles service was broken beyond repair. Unfortunately their web service
  is not operational either and I have had to decide to either continue support lacking 
  the web service or to discontinue this service.

[Changes]
- Improved German translation (thanks Maase!)
- Create Multiple for audio tracks now starts the numbering based on the highest track
  number currently in use
- Small changes to the loan information; removed "days till overdue" and added "status"
  and "# days"
- The Loan administration form will now open the loan information directly on a double
  click

[New]
- Google.com book search, allows for searching both on keywords and ISBNs
- Greatly improved loan administration overview; you can now search for loans and also
  choose to see only current and/or historic loans.

[Fixed]
- Descriptions and images as retrieved from Sourceforge.net have been improved
- Web application does not show any items when one of the loan fields has been selected
- [3515767] The file importers now check on the item ID (if it exists) to find the 
  existing item
- Amazon service will now retrieve all authors and publishers
- Bol.com service for books was broken and now fixed
- Discogs.com service needed to be updated to reflect site changes (no tracks retrieved)
- The web client shows an item multiple times in case it has multiple references.
- The web client shows null, null for some references instead of nothing in case
  there is no value set
- The web client suppresses information in case an item does not hold a value 
  for the selected field. If categories are selected in the web field settings any item
  not having a category will not be shown. Now, they will be included.
- Longer wait time for the file synchronizer when there are no items found to synchronize
  (high CPU usage)
- Loan administration window size is not remembered.
- Loan administration overview is cleared when clicking on a column header
- The loan administration overview now refreshes after returning an item      
- Date field cannot be cleared
- Data Crow GUI will not close until the database has successfully been closed. This 
  to prevent situations where Data Crow started again while the database still in use
  by the previous session.


-----------------------------------------------------------------------------------------
Data Crow 3.9.12  [Released on March 10, 2012]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Changes]
- Added an option for the mass update to always use the first result. Note that this
  option does not work together with the 'use original settings' option.
- Added epub, microsoft Word documents, odt and chm support for the eBook file importer.

[Fixed]
- Fixed the check for existing external references to avoid problems when saving.
- [3467923], [3489871], [3474523], [3477841], [3484681] NullPointer when saving items.
- [3450698] Multiple author creation (unconfirmed fix).
- [3471896] IMDB.com; USA search doesn't work goes to default. 
- [3484660] IMDB-Import for Actors/Directors does not import pictures.
- [3484670] Undo current filter still does not work.
- Issue with the mass update where not all items are being updated (caching issue).


-----------------------------------------------------------------------------------------
Data Crow 3.9.11  [Released on December 30, 2011]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Filter ascending on multiple fields did not work correctly.
- Filters could not be saved for multiple relationship fields. After a restart of Data
  Crow they would appear as having a blank filter value.
- Saving a filter will now immediately update the quick filter tool bar.
- Errors related to an unexpected appearance of the COMPANY column in the database for
  persons. This column has now been removed to prevent NullPointerExceptions. 
- ISBNDB.com: error message when retrieving the number of pages for books.
- ISBNDB.com: error message when retrieving publishers and authors.
- Description fields had a maximum length of 8000 characters. This size has now been 
  changed to 2147483647 characters.
- Errors while merging external references.
- External references not updated after updating the item from an online search. 
- NullPointerException while importing an item from a CSV file without mapping 
  all fields.
- NullPointerException when selecting Undo Filter from the Filter menu.
- Upgrading from version 3.9.7 (or older) to 3.9.10 (or newer) is now no longer an issue.
- Incorrect size for multiple reference fields when viewing items as read only.
- Hyperlinks to items were not working.
- Support for underscores has been added to the file renamer.
- NullPointerException when searching for ASINs (related to CueCat scanner).
- Various upgrade problems from the 3.9.10 version related to the associate names;
  names empty after upgrade, names not shown in the table view
- Pictures not shown after removing one of the picture fields
- Bol.com no longer working
- Errors for online book searches after changing the category field to a multiple 
  relationship field.

[Changed]
- Upgraded to the latest version of jAudioTagger (2.0.4)
- IMDB.com update for non US searches will now place the local title in the Title (local)
  field and the English title in the "Title field". This is only true if the setting 
  "get local titles" is enabled. The option is off by default.
- Added an open to open items either in read only or edit mode by default. The setting
  can be found in Settings > Settings > General Settings. Additionally you now have two
  options in the right-click menu of an item "Edit" and "Open". By default the option has
  bee set to the old functionality which is to always open items in edit mode.
- Clicking on a column header will now ort the content of the table. Clicking again 
  reverses the order.


-----------------------------------------------------------------------------------------
Data Crow 3.9.10  [Released on November 19, 2011]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Amazon Search broken.
- Field content not fully shown for large text fields.
- Imdb.com ratings not longer retrieved.
- Improved error handling and additional methods to prevent items from being saved.

[Changes]
- Removed AWS key configuration.


-----------------------------------------------------------------------------------------
Data Crow 3.9.9  [Released on June 18, 2011]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Sorting and format of person names has been corrected for reports.
- Images were not removed from the media images folders after the item has been deleted.
  An upgrade process will remove all images that really should have been deleted 
  on removing the accompanying items.
- Images not always correctly updated by the online search.
- Incorrect text maximum length for long text fields.

[Changed]
- Default value for "Company / Organization" for associates is now set by default for
  company modules. Note that this value can be overruled by using a default template.
- The CSV importer will now import references correctly. Before it only supported single 
  values. Now it actually supports multiple items (genres, categories). Values need to
  be comma separated.


-----------------------------------------------------------------------------------------
Data Crow 3.9.8  [Released on June 13, 2011]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Sorting of artists, authors and other persons has been fixed. 
- Define fields in alter and create module wizard: Data Crow now correctly checks for the
  entered maximum length for a field. 
- Item importer states that the items are imported directly into the database. 
  However, the items are actually imported first into the new items tab. I have changed
  this so that the items actually are imported directly into Data Crow.
- The XML item importer for images imports an empty item for every imported image. 
- Non property modules could no longer be used as a reference for other modules (reference
  fields).
- Define Fields dialog did not have a help page linked (pressing F1 shows an empty page).
- Change password dialog did not have a help page linked (pressing F1 shows an empty page).
- Loan information overview did not have a help page linked (pressing F1 shows an empty page).
- In many cases the help does not clearly state where to find the functionality or option. 
- File Renamer functionality was broken due to performance problems.
- Possible undetected closure of the database connection.
- Discogs.com service was broken.
- References not correctly cleaned after removing an item.
- References are now always alphabetically ordered. 
- Fields not visible after creating a module.
- Database is locked after creating a backup (restarting fixes the problem).

[Changed]
- For persons (such as artists and authors) the name field has been changed to read 
  "Lastname, Firstname". On startup you will be asked to confirm the update.
- For associates (persons and companies) it can now be indicated whether it is a person 
  or a company. For persons, the name will read "Lastname, firstname". For companies
  no name conversion is done.
- Picture field can no longer be set to be a descriptive field.
- For associates the descriptive field can now no longer be set manually, it will always 
  be the name field.
- Define fields in alter and create module wizard has been changed to include:
  * Required = is the field mandatory
  * Descriptive = does the value of this field describe the item
  * Is key field = is this field use to check whether the item is unique 
  * Tab = the tab of the item form in which the field is placed (replaces the 
    "technical info" check box).
- Added an extra step to the module wizard to explain the additional settings that can 
  be done for the module after Data Crow has been restarted.
- Order of the labels in the chart panel has been changed.
- Updated the help in many places.


-----------------------------------------------------------------------------------------
Data Crow 3.9.7  [Released on May 12, 2011]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Image paths for reports are not relative, even not when setting "copy images" to true. 
- Error occurs when a default template is active in combination with the new item wizard. 
- None administrator users cannot loan items (error). Users having permissions to use
  the loan plugin is now always allowed to make updates and inserts into the 
  loan table.
- Saving a picture to disk doesn't work.
- IMDB service does not retrieve the full description.
- Enormous lag before importing.
- Error on the initial database creation script (harmless).

[Changed]
- The file selection for the various file importers has been changed to make it work
  faster and simpler to exclude and include single files.
  

-----------------------------------------------------------------------------------------
Data Crow 3.9.6  [Released on March 30, 2011]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Changed]
- Portuguese and english translation have been redone by Uruan. Thanks!!!!

[Fixed]
- Item form is opened twice from property views when another item was removed first.
- Memory usage when importing images from web or file information has been reduced.
- Memory leak for image saving and loading has been fixed.
- Pictures are sometimes not drawn in both the new and current items tabs.
- When checking whether an item already exists in the database (such as a language or
  country) Data Crow will now take trailing spaces into account. An update is performed 
  during the upgrade to remove all trailing spaces from existing items (related to the
  IMDB.com movie search update)
- Cannot remove contact person when the person has lend items.
- An error is logged in the log file when updating or adding an item after opening 
  the container module 


-----------------------------------------------------------------------------------------
Data Crow 3.9.5  [Released on February 13, 2011]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Can't close the image file import dialog.
- Importer fails with 'NullpointerException'
- Mobygames.com site change; pictures no longer retrieved.
- New user folder created on initial installation (not used).


-----------------------------------------------------------------------------------------
Data Crow 3.9.4  [Released on February 6, 2011]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- IMDB service not working
- File import for images no longer working
- Upgrade error (due to extensive logging)
- Incorrect Look and Feel for software module (only on first startup of a fresh install)
- File import dialog > settings; added "create" button for storage medium and fixed 
  create new button for container
- AWS Access Key cannot be changed after performing a search (restart was required)
- Create multiple did no longer for property modules (NPE)
- Templates do not load references (references are not applied on the new item)

[New]
- MovieMeter.nl online service!


-----------------------------------------------------------------------------------------
Data Crow 3.9.3  [Released on January 25, 2011]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- In some cases the new item wizard window was not shown. 
- Security: users were able to select a value from a list while not having permission 
  to do so (item form; drop downs).
- Newly created items for a reference field (from within the item form) were not added
  and selected.
- Create buttons active while not having permission to create items.
- File import (movie/music albums): zeroes are set as values while these fields should 
  actually be empty.
- MKV file import: incorrect video bit rate (8bits, always)
- Keeps CD/DVD mounted after failed data fetching (MKV).
- Softpedia did not recover screenshots anymore

[Changed]
- Focus is set to the "Search for" field after items have been found or the search has
  been canceled (online search form / new items wizard).
- Correct representation of what is enabled in the menu (toggle quick view, etc). 
- Permissions can now be set on any module, including the property modules.
- Updated jTattoo library to the latest version (December, 2010).
- Updated jAudioTagger to version 2.0.3 (from 1.0.9)
- Any custom made module can now be exported and imported, including property modules.

[New]
- Find and replace tool
- Support for CueCat Barcode scanners in the online search form.


-----------------------------------------------------------------------------------------
Data Crow 3.9.2  [Released on January 7, 2011]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Could not sort on actors, authors, artists and other multiple-references fields.
  Note that the items are sorted based on the first entry of the multiple references
  field. So if you have assigned two actors to a movie, Jan Jansen and Richard Howard,
  the first entry will be used to sort the item (in this case Jan Jansen). 
  Technically this has been accomplished by store the first string representation in 
  a separate field which is used to base the sort on. This field is kept in synch with 
  changes made (cleared in case no entries, updated with first entry in all other cases).
- Countries and properties could not be edited.
- Items not removed from the card view after saving them.
- Container tree does not get updated correctly with parent - child relationships.
- Unconfirmed fix; memory leak when importing movies file information.
- Settings were only taken into account (import > online search) after the dialog
  was closed and re-opened.
- File import, search for additional information on sub items, did not work for
  actors and directors when working with imdb.com.
- Filter dialog could not be opened from within the Book module.
- After updating an item the node in the tree becomes unreadable (appended with .. and
  not showing the whole text) 
- Web client advanced filter did not handle advanced filter correctly where no value is 
  required.

[Changed]
- Associates are now part of a specialized associates module. The create module wizard
  now allows you to select the 'person' module type.
- You can now configure the maximum number of actors to be retrieved when querying for
  movies from Imdb.com. Click on the configure button next to the server drop down to 
  change the value. By default all actors will be retrieved (old/current behavior).
- Fields can now be selected when exporting items (CSV/XML exports. Field selection is
  remembered for next time(s).
- Double-clicking a multiple references field now opens the select windows.
- Removed labels in quick view for images.
- Added additional filter operators for dates (today, days ago, days in the future,
  months ago and years ago.

[Known Issues]
- Removed the settings for persons (default sort order and display options); these
  did not work and need to be re-implemented. Planned for next version.


-----------------------------------------------------------------------------------------
Data Crow 3.9.1  [Released on January 3, 2011]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------
The "Happy New Year!" additions.. ;-)

Building upon the changes made in Data Crow 3.9 this release offers more performance
improvements and fixes.

[Changed]
- Within the Amazon Server Configuration you can now enter your AWS Access Key ID and 
  the Secret Key. By default a shared access key is used which can cause timeouts when
  multiple users are trying to query the server. Registering to the AWS site will provide
  you with your very own access key. Accounts can be registered here:
  http://aws.amazon.com/
- Icons are now shown in both the Quick View and the Item Form.

[Fixed]
- Values removed after saving an item using 'save all' from the tool bar.
- Any '&' character used in the module wizard caused Data Crow to crash when restarting.
- Data Crow slows down when switching between modules or filter fields;
  when the quick filter was build the list of possible items was retrieved. In case of
  10.000 or more actors (for example) this would take about 30 seconds to be filled. 
  Now, this only takes a couple of seconds.
- Very slow working "Advanced Filter" editing. Basically the same issue as mentioned 
  above; when the select box is filled with for example 10.000 actors Data Crow would
  crawl to a halt.
- Very slow working "Web Server". Same issue as mentioned above, related to retrieval
  of values for the quick and advanced filters.
- Added re-use of database connections for better performance.
- Extremely slow module importer.
- Items not removed from the table view when saving new items.
- Improved the speed for deleting massive numbers of items.
- Improved the speed for saving massive numbers of new items.
- Fixed issues where view would loose focus when saving updates.
- Icons are now cached. On first startup you might experience a slow down when starting
  the system. Second startup will eliminate this slow down.
- The character "'" in a field definition would break the reporting module
- The character "&" in a field definition would break the XML module, causing Data Crow
  to crash
- IMDB added a trailing space behind the title of a movie
- Not all genres of a movie were imported from IMDB
- Cannot launch files from the quick view panel
  
-----------------------------------------------------------------------------------------
Data Crow 3.9.0  [Released on November 15, 2010]  [testing: high]  [target: production]
-----------------------------------------------------------------------------------------
This release delivers a significant, mostly technical, change. The data layer, which 
is the way for Data Crow to load and display items, has been rewritten.
Items were always loaded (all of them) on startup, causing a long startup time and 
high memory usage.  

The new data layer increases the startup time of the product and lowers the memory 
requirements. On the down side you might notice a slight performance decrease when 
scrolling up and down in the views. This is because Data Crow now loads the items
when they become visible on screen. Due to a smart caching mechanism the performance
decrease has been kept as minimal as possible. On the plus side the grouping pane and
the startup time have improved significantly (by about 75%). Additionally it is now
possible to load a large database just as quickly as a small database, with the
same memory requirements!

The following has a direct impact on the performance of the system:
- The number of selected field as the description for an item 
  (View Settings > Description). Data Crow only queries for the necessary information,
  having to query for, for example, a name, category and a container will take 
  more time when loading the item on screen.
- Available memory for Data Crow (Java -Xmx256m is recommended).

New System Requirements:
- Minimum amount of memory: 128MB
- Recommended amount of memory 256MB.
- Sun Java 1.6 or higher.

[Known issues]
- Java will start consuming a lot of the processor time when the application is running 
  out of memory. Assign 256MB's to the application to make sure that this does not happen.

[Changed]
- Improved startup time (75% faster)
- Lower memory usage (50 to 70%)
- Items are always loaded directly from the database, no caching
- Grouping pane improvements (50% faster)
- Unique identifiers are now generated according to the UUID Java standards.
  (For future compatibility)
- Added indexes on database tables. This done automatically, also for custom modules.
- Items are only loaded if and when they are actively shown on screen.
- Changed the layout of the quick view.
- Updated Apache FOP to version 1.0; increased performance for report creation.
- Showing a progress bar when building the tree / grouping panel
- Pictures are now shown within the quick view panel. If a picture field is added 
  to the description of the quick view panel it will no longer be displayed in a 
  separate tab.
- Toolbar can now be completely disabled (F12).
- Garbage collection scheduler is now disabled by default. If needed it can be turned
  on in the expert user dialog.
- Fields in view settings and grouping pane can now be ordered without having to 
  remove and add the fields again.
- Added m4a to the music file importer.
- Added an option to enable high quality rendering of images (lowers performance and
  increases memory usage).
- Improved performance for the chart panel.
- Using JFreeChart libraries instead of OpenChart2, allowing for better graphical 
  chart presentations and printable charts.
- An option has been added to the quick view settings to show or hide the picture tabs.
  This is a 'per module' setting.
- Default full expansion of the grouping pane tree nodes has been disabled.
- Removed the table view from the user module.
- Added expandAll and collapseAll to the file tree panel.

[Fixed]
- Image not shown (or flickering) in the card view
- ConcurrentModificationException on several occasions
- Web version is not in synch with item changes done in the client(s)
- High overall processor usage.
- Quick filter; sometimes the list is not filled correctly
- Changing fonts; not properly delegated to all views / components
- File structure not displayed correctly in the File Structure tree.
- Open report button was enabled even when the report was still being processed.
- IMDB search; most information was not imported due to site changed
- IMDB search; multiple directors was not working
- MetaCritics online service no longer working (games & movies).
- FreeBookSpot could not be repaired and has been removed.
- Bol.com online service retrieved "no image" pictures.
- Barnes & Nobles search was completely broken.
- Discogs.com; images were no longer imported.
- MCU.es was beyond repair and has been removed.
- First visible field in item form is now selected / focused.
- Child items are not added to reports if running in other language then English.
- Report PDF "audiocd listing desert" doesn't display Artist
- Report HTML "software listing desert" had publishers instead of categories.
- Directory usage section of the file importer had a strange looking border.
- History on loans not directly updated, only after reopening the item form.
- Right-click 
- Help on item form mentioned "attach file info" while it should read 
  "read file information"
- File > Locate File options were available even when the item does not have 
  a hash or file size set.
- Item updates done by external processes no longer cause focus loss on the client
  (File Synchronizer & web application).
- Removed defective 'brighten' function for pictures.
- Item Synchronizer does not update all items.
- Duplication of records for multiple references fields; duplicates are removed and 
  a unique index is set on these tables to prevent this is in the future. 
- Duplication of records in the picture tables; duplicates are removed here as well
  and a unique index is created here as well.
- Item is only removed and re-added to the tree if the value has changed of the field
  that is part of the tree structure (performance gain).
- Column widths for the child table (tracks for example) are not remembered.
- Reports does not a comma between listings of categories, genres, etc.
- Containers were not added correctly to the reports. The reporting dictionary did not
  correctly describe this multiple reference field. 
- The message 'This item is not unique, it already exists.. ' (etc) did not correctly
  tell you why the item is / was not unique.
- Bol.com did not retrieve any results as of November 8th, 2010. Fixed.
  (Incorrect HTML syntax on Bol.com: href=""/nl/s)
- License information for software not save (incorrect column name).
- User information could not be changed, message appears 'login name cannot be changed'
  while the login name has in fact not been changed.
- MobyGames.com; &#x27; in titles instead of '
- Discogs online search no longer retrieved the titles for tracks correctly 
  (HTML change on Discogs site).
- Imdb person search appends "- IMDb" to each name.


-----------------------------------------------------------------------------------------
Data Crow 3.8.16  [Release on June 19 2010] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Unlikely but possible errors when saving child items.
- Lend / borrowed grammar mistakes.
- Is Filled and Is Empty operators have been corrected and now work for all fields.
- Can now filter on "Not yet rated".

[Changed]
- Added additional help (explanation on default modules).


-----------------------------------------------------------------------------------------
Data Crow 3.8.15  [Release on June 15th 2010] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Images not added when updating an item.
- IMDB movie search only fetches the first director.
- Context menu "delete" deletes wrong item.
- Cache/DB inconsistent after report creation.
- Pictures not visible.
- Softpedia.com is no longer working.
- Flickering images.
- Item sorting has been amended to deal with special characters.

[Changed]
- Items can now be added when opening them from the online search form.
- Multiple containers can now be added to a single item.


-----------------------------------------------------------------------------------------
Data Crow 3.8.14  [Release on May 27th 2010] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Item wizard does not add images.


-----------------------------------------------------------------------------------------
Data Crow 3.8.13  [Release on May 7th 2010] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Track titles were missing for Discogs.com.

[Changed]
- 2927679 Collapse All Behavior
- 2943392 Floating Filter Dialog
- 2943409 Filter - Does not Show working status
- 2944044 Amendment to the Sort Order (filter)
- 2948618 Add 'copy' option to quickview
- 2948686 Close Tool Select Wizard after choosing & better explanation
- The 'container managed' option is now also available when altering a module.
- 2955087 Suppress "There are no changes to save" dialog
- Backup & Restore is now also available when running in the beginner experience level.
- 2955092 Visual indication of Beginner/Expert mode
- Added the username to the title of the Data Crow window.
- 2943367 Filter to select Pictures "is empty"
- Added "Is Filled" option to the quick filter toolbar.
- Added HH:mm (hours and minutes) to the backup file name.
- 2989153 Comment Addition for Backup files. A comment can now be added to a backup file. 
  The comment is shown when browsing for a backup file to restore.


-----------------------------------------------------------------------------------------
Data Crow 3.8.12  [Release on May 3rd 2010] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Changed]
- Updated French translation! Thanks to Skorpionnan.

[Fixed]
- 2991768 Can't close detached dialog window after item delete (unconfirmed fix)
- 2984361 Custom property module not in delete wizard
- 2988925 Regional Settings - Decimal Grouping Error (can now be left empty)
- 2988556 IMDB import adds trash chars to Genre item
- 2988565 IMDB import fails to parse some years
- 2987886 Concurrent Modification Exception in FreeResourcesTask
- 2987098 Containers (containers are now removed from the view after deleting them)
- 2970691 Item wizard with ISBN search adds item directly
- 2970693 ISBN online search does not retrieve results (bol.com)
- 2981541 Director field IMDB.com (now adds aspect ratio, director and color to movie)


-----------------------------------------------------------------------------------------
Data Crow 3.8.11  [Release on 14/03/2010] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Changed]
- Updated Italian language pack (big thanks to Marco Artioli).

[Fixed]
- Update all was not available from the tools menu.
- Web Server cannot be started from the command line.
- Item cannot be deleted after opening it from within the child tab of the item form.
- Item of custom module with child relation cannot be deleted. Data Crow states that 
  there are referencing items (the children). It should however be able to delete this
  item regardless if it has children or not (and delete the children).
- NullpointerException when starting Data Crow after restoring a database. Due to a
  missing field the UI fails to initialize correctly and causes Data Crow to shutdown. 


-----------------------------------------------------------------------------------------
Data Crow 3.8.10  [Release on 16/02/2010] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
Note: Known performance issues will be fixed with the 4.0 version. These cannot be solved
in the current Data Crow 3 version.

[Fixed]
- Bol.com was no longer working (item links on bol.com were changed).
- Altering a module made the file fields disappear (the property 'file-backed' was not 
  saved correctly).
- The FreeDB server did not deliver helpful error message when the disc query failed.
- The error handling of the report creation process has been improved. 
- Data Crow did not remember (after a restart) whether its main view was maximized.
- Table view duplicates tracks when saving a new item.
- The list disappears when altering a property from within one of the administration 
  menu options.
- Forms for child modules cannot be designed (the menu item is not available).

[Changed]
- The installer allows you to select the specific modules you would like to install.


-----------------------------------------------------------------------------------------
Data Crow 3.8.9  [Release on 13/02/2010] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
Note: Known performance issues will be fixed with the 4.0 version. These cannot be solved
in the current Data Crow 3 version.

[Fixed]
- Imdb.com was no longer working.
- Audio Tracks were no longer updated by the online search and synchronizer.
- Flickering pictures in the view.
- Log file created in the old location (previous installation of Data Crow).


-----------------------------------------------------------------------------------------
Data Crow 3.8.8  [Release on 05/02/2010] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Memory issues with the images module.
- Photo of persons not shown in the picture tab of the quick view.
- Switching between look and feels does not always work correctly.

[Changed]
- Log form is now scalable (size is remembered) and correctly styled.


-----------------------------------------------------------------------------------------
Data Crow 3.8.7  [Release on 06/01/2010] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Changed]
- Mass updater will first search for an item using the unmodified title or name of the 
  item. If no results were found for the specific item Data Crow will try and clean up
  the title and find a match. Additionally the logging has been improved; the log will
  tell you if a match was using which search string.
- Added meaningful tool tips for all menu and tool bar items.
- Improved error handling for startup errors.

[New]
- Added a new wizard; Tool Select. This wizard helps new users in selecting the right
  tool for the job they want to perform.
  

-----------------------------------------------------------------------------------------
Data Crow 3.8.6  [Release on 31/12/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
Contains for the most part bug fixes but also introduces changes to the image module.

[Fixed]
- Incorrect translation of tabs in the software module (only fixed for new installations)
- Several small memory leaks concerning images.
- Image not always saved; newly added image are marked as updated images causing them
  to be discarded.
- Cannot perform online search for items having a ' in the name.
- Picture not shown in the images detail page of the web GUI.
- Local art tab is shown for the image importer.
- Data Crow cannot be started after installing it without the modules.

[Changed]
- Images are no longer copied in their unmodified state to the Data Crow images folder.
  The image will now first be scaled (400x400).
- The link to the original image is now used to display the original image (if it is 
  available).
- A new option has been added to the file importer: save directly. This option adds 
  items directly to the database, bypassing the new item tab. This saves both time and
  memory.
- Selected server, mode and region are now remembered for the Mass Update functionality.
- Queries as entered in the online search form are now used in their unmodified form.
- You can quickly add a new drive (directory or network location) from within the 
  File Import dialog.
- Quick filter toolbar; you can now search for child items 


-----------------------------------------------------------------------------------------
Data Crow 3.8.5  [Release on 9/12/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Discogs.com online service no longer retrieved the tracks.
- Memory leak in the card view. Data Crow will now use a maximum amount of memory.
  After that, additional memory is actively released to the system.
- File size is cleared when saving an item of which the file does not exist.
- [2909635] Failure after installing without modules. Data Crow can now actually be 
  started without having any of the default modules available.
- Non picture fields are displayed in the pictures settings for the card view.
- [2909608] Cannot delete empty back picture.
- [2909589] Update all still malfunctioning.
- [2909593] Null Pointer Exception when importing Movies
- [2909591] No directory sort order in Movie import dialog

[Changed]
- Selected container and storage medium for the file importer is now remembered for a 
  next run.
- Default picture order for the card view has been corrected (front, media, back).


-----------------------------------------------------------------------------------------
Data Crow 3.8.4  [Release on 3/12/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Update all was no longer working.
- I had to remove the skin look and feel options. The performance of Data Crow in 
  combination with the skin look and feel is very bad compared to the normal look and
  feels.
- The cards in the card view have been made bigger. This also fixes the issue where
  images are clipped / displayed partially. 
- Images exported by the item exporter and the reporting tool were corrupted.
- Report creation process could not be canceled. 
- Online update duplicates tracks. 


-----------------------------------------------------------------------------------------
Data Crow 3.8.3  [Release on 26/11/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Related modules are not correctly imported using the module import wizard.
- Hierarchy container tree does not update correctly when changing the parent of a 
  container. 
- Invalid container hierarchies are not prevented (unending loop).
- Update all does not update items when the validation of an item fails.
  This is fine but no error is shown to the user.
- NullpointerException when deleting a custom made module (rarely occurs).
- Imdb.com online service was no longer working.
  Cobra project: Imdb.com HTML was no longer valid for this library. The cobra.jar 
  library has been altered to correct this. 
- Changes made to the contact person module were saved to the wrong module JAR file.


-----------------------------------------------------------------------------------------
Data Crow 3.8.2  [Release on 17/11/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
Maybe I am taking the 'release often' approach to its very limits.. here is yet 
another minor release containing small fixes and an additional online service.

[Fixed]
- Genres for movies retrieved by IMDB were, sometimes, appended by " more". 
- Sorting: sort settings overruled the sorting of a filter created in the filter dialog.
  Now this filter dialog sorting is remembered. Changing the sort after applying a filter
  overrules the sorting of the filter. 
- Description was not retrieved for software from Sourceforge.

[Changed]
- Updated Italian translated. Thanks Marco Artioli! 
- Added a new reference to the software module: License.

[New]
- Softpedia online service. Retrieves information on drivers and Linux, Mac, 
  windows and game (related) titles. Together with the previous new online services 
  (Sourceforge.net and FreeBookSpot) Data Crow now offers information on downloadable 
  (free) content instead of solely using the online service to retrieve information on
  commercial titles. You can expect more of these kind of services to be added in the
  near future.


-----------------------------------------------------------------------------------------
Data Crow 3.8.1  [Release on 15/11/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Categories and such could still be deleted even when used by other items.
- French translation was added incorrectly to the installer package (sorry Skorpionnan)!
- Errors when trying to delete an item (Date cannot be cast to collection of DcObject). 
- Quick View does not display the item when the contact person module has been disabled.
- Error in queries when only references have been changed for an item.
- Only 10 custom property modules could be created. In the new setup you can have an 
  unlimited amount of custom property modules. 
- Cache is now always cleared when upgrading from an older version.
- Possible error during module import; importer tries to update a view which is created\
  only after restarting Data Crow.
- Item importer (XML) failed when a field name (XML tag) started with a numeric value.
  These fields are now appended by 'fld-' to create a valid XML tag. 

[Changed]
- Added the file backed and the container managed properties to the module wizard.
  These option were already available but only by editing the module XML manually.
  The file backed property adds the file size, file hash, hash type and file name field
  to the module. The container managed property adds a container field to the module
  and allows the items belonging to this module to be displayed within the container
  module. 
    

-----------------------------------------------------------------------------------------
Data Crow 3.8  [Release on 10/11/2009] [testing: moderate] [target: production]
-----------------------------------------------------------------------------------------
The 3.7 version contained errors which were not noticed while the 3.7 was in its
beta stage. This release fixes 'all' of these issues. Note that this version has only be 
tested moderately. 

[New]
- Metacritic game and movie online service. An excellent resource for game and movie
  reviews.
- FreeBookSpot online service. A site from which e-books can be downloaded.
- Added sourceforge.net as an online service. Sourceforge.net hosts open source projects
  like Data Crow and many others.

[Changed]
- Invalid auto numberers are now automatically removed on startup. They can become 
  invalid due to removal of the field from the module.
- Added additional checks to see if an item was destroyed. Picture objects are now 
  also internally recycled.
- The drive scanner and drive poller (part of the Drive Manager) can now be configured
  (from within the Drive Manager dialog) to run on startup. 
- The category field of the software module has been changed to a multi-reference field.
- Items can no longer be deleted when referenced by other items.

[Fixed]
- Reserved keywords could be used as module and field names causing all kinds of startup
  errors. Data Crow now actively checks whether the name is allowed.
- NullPointerExceptions when starting Data Crow and while working with items in 
  the views.
- Grouping pane looses its grouping.
- Picture disappears when updating a newly added item. 
- Strange images being written to HTML reports.
- NullPointerException when creating a report.


-----------------------------------------------------------------------------------------
Data Crow 3.7  [Release on 07/11/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
No new functionality but a lot of memory and performance improvements. The changes
made cause a dramatic performance increase as well as a substantial memory gain.

This list of changes and fixes is the combined list of this and the 3.7 beta release.

[Changed]
- Increased the speed of the file synchronizer.
- Items are now internally reused. Data Crow was quite generous when it came to item 
  instances. To gain, I admit, a modest performance and memory usage gain items
  are now internally re-usable. As a user you will not really see this change. However,
  this change has such a big impact on the whole of the product that I have decided to
  release this version as a major release and to release it as a beta version first.   
- Several performance fixes have been applied. The external references and the additional
  checks performed when saving an searching for items caused the performance to drop.
  To overcome these issues (for large databases) the checks to see whether an item 
  already exists have been changed; 
  * For properties both the alternative names and the names are checked.
  * For all other items the external references are checked first (the PDCR in particular).
    Secondly a (combination of) display field is checked. Since version 3.5 Data Crow
    only checks on the actual string (exact match but case insensitive). This has been
    kept this way.
- Views are now filled instantly resulting in a 99% performance improvement. With this 
  change items are added to the view in about a second (regardless of the amount of items). 
- View components are now reused (reduction of item creation; lesser memory needed and 
  performance improvement).  
- Memory needed for viewing all items now requires about 75% lesser memory. This is not
  a fixed memory gain as it also depends whether the items contain an image (etc.).
- Save buttons are now removed from the item tabs of the view. Save and save all is still
  available from the menu bar and the tool bar.
- Update all now saves the updates directly (!).  
- Displaying dialogs is now more controlled (technical change).

[Fixed]
- Templates could not be saved.
- Templates are not correctly displayed in the view.
- Template form does not show tabs as defined for the item itself.
- Images not displayed in the web application if the images/modules folder does 
  not exist.
- Reference values such as actors and genres could not be saved (introduced by 3.7 beta).
- Picture disappears when lending an item. The image reappeared after restarting 
  Data Crow (introduced by 3.7 beta).
- External Reference is not created when an item is updated by an online service.
- Several problems with transparent images have been fixed.
- MobyGames.com stopped working.
- Items are not correctly updated in the tree / grouping pane.
- Key navigation in table view.
- Issues with update all functionality when loosing view focus.
- Data Crow hangs after message "want to save changes" when navigating in the grouping 
  pane.
- By default the directory usage has been turned on for the File Importer. Has been
  changed to off by default.
- Calendar displays February twice if the current day of the months is greater than 28.
- "Hanging startup" on some Linux flavors.
- Several references in text to Java 1.5; should be Java 1.6.    
  

-----------------------------------------------------------------------------------------
Data Crow BETA 3.7  [Release on 30/10/2009] [testing: medium] [target: BETA]
-----------------------------------------------------------------------------------------
No new functionality but a lot of memory and performance improvements. The changes
made cause a dramatic performance increase as well as a substantial memory gain.

Note that this is a beta version; limited testing has been performed! Please create a
backup of your database before using this version.

[Changed]
- Items are now internally reused. Data Crow was quite generous when it came to item 
  instances. To gain, I admit, a modest performance and memory usage gain items
  are now internally re-usable. As a user you will not really see this change. However,
  this change has such a big impact on the whole of the product that I have decided to
  release this version as a major release and to release it as a beta version first.   
- Several performance fixes have been applied. The external references and the additional
  checks performed when saving an searching for items caused the performance to drop.
  To overcome these issues (for large databases) the checks to see whether an item 
  already exists have been changed; 
  - For properties both the alternative names and the names are checked.
  - For all other items the external references are checked first (the PDCR in particular).
    Secondly a (combination of) display field is checked. Since version 3.5 Data Crow
    only checks on the actual string (exact match but case insensitive). This has been
    kept this way.
- Views are now filled instantly resulting in a 99% performance improvement. With this 
  change items are added to the view in about a second (regardless of the amount of items). 
- View components are now reused (reduction of item creation; lesser memory needed and 
  performance improvement).  
- Memory needed for viewing all items now requires about 75% lesser memory. This is not
  a fixed memory gain as it also depends whether the items contain an image (etc.).
- Save buttons are now removed from the item tabs of the view. Save and save all is still
  available from the menu bar and the tool bar.
- Update all now saves the updates directly (!).  
- Displaying dialogs is now more controlled (technical change).

[Fixed]
- External Reference is not created when an item is updated by an online service.
- Several problems with transparent images have been fixed.
- MobyGames.com stopped working.
- Items are not correctly updated in the tree / grouping pane.
- Key navigation in table view.
- Issues with update all functionality when loosing view focus.
- Data Crow hangs after message "want to save changes" when navigating in the grouping 
  pane.
- By default the directory usage has been turned on for the File Importer. Has been
  changed to off by default.
- Calendar displays February twice if the current day of the months is greater than 28.
- "Hanging startup" on some Linux flavors.
- Several references in text to Java 1.5; should be Java 1.6.    


-----------------------------------------------------------------------------------------
Data Crow 3.6 [Release on 18/10/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
! Note: The minimum Java version is now Java 6 (also known as Java 1.6).
! Special thanks to David Marín for delivering the Spanish translation.

[New]
- A Spanish translation. Donated by David Marín. 
- New feature for the File Import of e-books. The importer will now try and find the ISBN
  that is contained in the PDF document. For this the ISBN Extractor 
  (http://isbnextractor.sourceforge.net) is used.
- Each item can now have one or more external keys. External keys, such as ASINs from 
  Amazon, are used to link the item from the source where they were obtained from. 
  They add additional flexibility and lend themselves to be used by other systems and 
  customization.
  This solves problems where items could not be linked to the source system and were
  therefore duplicated. Most notable example are the actors for IMDB movies. 
  The name was used to check whether the actor already existed in Data Crow. This worked
  fine when the name is not changed on either side as this breaks the link between the
  Data Crow and the item of the source system. Now, the external IDs are used to link
  the items. Where there is no external ID available Data Crow uses an internally 
  generated item tag instead.
  In short: items are now more reusable then ever!
- Module Export Wizard. This wizard enables you to share your modules with other users.
  With this wizard it is now possible to export your custom made modules and their data.
  It creates a single archive which can be imported on any other Data Crow installation
  by using the Module Import Wizard. It exports the reports, items of the module(s) 
  (based on the settings), settings and reports (xsl).
- Module Import Wizard. Takes care of all the nitty gritty stuff that is involved when 
  you want to add a custom module to your Data Crow installation. This is, from now on,
  THE way to add custom modules to your installation. It takes care of internal module
  ID clashes, imports the items belonging to the module(s) and imports all other related
  information (such as the default settings and reports).
- Module Copy Wizard. Tired of adding all the fields manually to your custom module?
  Why not base it on one of the existing modules? Use this wizard, select the module 
  which you would like to copy and off you go!
- A new parameter has been added: -datadir:<directory>. This parameter can be used to 
  specify an alternative location for the data folder of Data Crow. Note that the images
  will still be written to webapp/datacrow/mediaimages (in the installation folder).
  Substitute spaces by %20.
- Container hierarchy: Containers can now be assigned a parent, allowing users to create
  a hierarchical container structure. The grouping pane of the container view has two 
  additional options: 'Flat view' and 'Hierarchical View'. 
- File operations: The view popup menu and the file launcher field have a new menu
  called 'File'. Here you'll find five new options:
  * Move file: moves the actual file and updates the filename of the item.
  * Delete file: deletes the actual file and clears the filename of the item.
  * Locate file: three options to locate a file using the drive manager. This is a 
    convenient way to locate an individual file that has been moved. The functionality
    uses the drive manager functionality and offers to match on filename, filename +
    file size or on file size + hash. 
- Each property can now have alternative values. This is convenient in case you want to make
  sure that properties retrieved by online services are mapped to your own properties. 
  The alternative values have to be entered separated by ';' characters. The input needs to
  start and end with a ';' character.
- A new book online search: ISBNdb.com. This online service retrieves the book information
  from ISBNdb.com and the front cover from Amazon.com.

[Changed]
- Added additional font rendering options (Settings > Settings > Font).
- File and URL launcher: both have been updated to use the Java 1.6 methods for launching 
  files and URLs. Additionally the feedback to the user has been improved in case the file
  or URL cannot be opened.
- Quick View: URLs are now displayed as "link" instead of mentioning the full URL.
  This also fixes the issue where text in the Quick View is not being wrapped.
- File Importer now remembers whether it should use online services or not + the selected
  server, search mode and region.
- File Importer now remembers the selected "directory usage". 
- Quick View: filename is now a click-able link with the filename (excluding the path) as
  text.
- Default data is now loaded right after the data layer has been initialized instead of 
  during the database creation process. This delivers greater control on the load process
  of default data.
- Floppy drives are no longer ignored (due to the upgrade to Java 6).
- ASIN fields have been removed from the movie, software, audio CD and music album modules.
  The ASINs have been migrated to the new external references field.
- Disc ID fields have been removed from the audio CD and music album modules. The Disc IDs
  have been transferred to the new external references field. 
- Updated several of the icons for the property modules.
- The individual 'maintain' view popup menu options have been put in a separate 'maintain' 
  menu.
- The property modules 'edition type' and 'binding' for books are no longer contained in the
  modules folder. They are created within the system instead (same as all other system 
  property modules). The editiontype.jar and binding.jar files are removed on startup.
- The movie module has obtained addition fields; color and aspect ratio.
- IMDB online search now retrieves the color, aspect ratio and language.
- Amazon service now retrieves the color (if available) and the aspect ratio.
- Ofdb.de now adds an external reference to the item on the IMDB.com page.
- Icons_user directory has been removed. Icons_system folder is now called icons.
- Default data (demo data) can now also be an XML file. 
- The Dutch translation has been updated.
- The help has been updated.

[Fixed]
- "Pick a Date": larger set of years to make the navigation easier + a fix for the up and 
  down error of the year (both went back in time). 
- XML Export: Dates are now always exported like so: yyyy-MM-dd. This prevents problems
  when importing dates into other systems.
- IMDB online service: when a movie has several countries it is imported as a single
  country (item "USA, The Netherlands" instead of two separate items).
- Several encoding issues for the online services.
- Exported items using the XML exported can not be imported on a system using a different
  language pack.
- Online Search: the setting 'values to retrieve' is completely ignored 
  when the setting 'retrieve full item details on initial run' is switch off. 
- Discogs online search did no longer retrieve the tracks and other information. The
  Discogs site was changed and this broke the online service. This one has been
  reimplemented.  
  

-----------------------------------------------------------------------------------------
Data Crow 3.5.1 [Release on 26/09/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- File size for file hashing now allows larger file sizes to be set. Setting the value to
  zero will now allow hashes to be created for files of any size.
- After doing a mass update of, for example, audio CD's the artists and such were 
  mentioned twice. After a restart everything returned to normal.
- The FPS for MPEG 1 and 2 movies was off by a factor of a thousand frames. There is
  no update performed on old information; the fix only works for newly imported movies.
- Timeout on online searches has been removed; the result was a not updated movie after
  10 seconds without knowing the reason why. Especially true when performing and online
  search in combination with the "retrieve additional information for companies 
  and persons" setting (which might actually take more then 10 seconds).
- Additional check for locked databases. Added a check for the settings of the database.
- IMDB import: some runtime of the imported run times are incorrect (of by tens of hours).
- Splitting the names of IMDB persons is incorrect. Only true for names ending with 
  a number like so: Harry Potter (1).
- Sorting did not work correctly for the container module.
- Possible issue with scrolling in views (inverted up and down scrolling).
- Occasional error while performing an amazon online search: 
  Incomplete trailing escape (%) pattern 
- Barnes & Nobles online search was once again broken.

[Changed]
- The database no longer runs in a locked mode. This means you can start multiple 
  sessions of Data Crow or run both the web server in console mode and the Data Crow 
  GUI. Optimistic locking is used for database records (who ever saves the data 
  overwrites data saved by the other user working on the same record).
- Changed the description retrieved for actors (better styled, removed boilerplate 
  text).
- Removed boilerplate text for movies retrieved by Imdb.com and ofdb.de.
- Module wizard: from now on newly created modules can be reused within relationships.
  In previous versions a created module, such as a property module, could only be used
  once for a reference field. Now you can actually create one property module and use 
  this module (and it's data) for reference fields of multiple other modules.
  

-----------------------------------------------------------------------------------------
Data Crow 3.5 [Release on 20/09/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
The distribution has been changed. There is no longer a separate Web Module package.
Instead all have been merged together. This makes the distribution a bit larger but puts
the web module a bit more into the spotlight. The installer offers the option to exclude
the web module. The zipped distribution contains, of course, everything (including the
web module).

Thanks to Ingo Macherius for designing and donating the new movie report 
(List Report (xvids) and for helping to test the upgrade process.

[Fixed]
- The version checker does not recognize 3.5 as being a higher version then 3.4.19.
- ISBN search with ISBN's containing non-digits now also (finally) works.
- Movie import "settings" Tab: Storage Medium items are gone.
- Encoding issue in IMDB import. 
- Bol.com did no longer retrieve the description (page was changed).
- Incorrect font for drop-down / list boxes.
- Contact person drop-down / list box remains empty (loan administration).
- Could not set an empty value for a drop-down field.
- Web Server: Module icons are not refreshed when changing the icons using the 
  module wizards.
- Web Server: Large module icons shown for helper modules. 
- General errors while retrieving results from IMDB.com and Amazon
  (empty message pops up and a NullPointerException is logged).
- Year was not always set for IMDB movie results.
- Alapage.com online search has been removed. The page has been redesigned making 
  it necessary to create a new implementation. This will be done in a later version. 
- MusicBrainz search: titles of album and tracks start with a new line character.
 
[Changed]
- File import for e-books: if the filename contains an ISBN it is used to query the
  online service.
- Online Search: if the query contains an ISBN it is used to query the item.
- Mass Update: if the item contains an ISBN it is used to query the item.
- Audio CD search (Amazon): when an album consists of multiple CD's the album is no 
  longer duplicated. Instead all tracks are added to one album 
  (with the correct numbering). 
- Amazon search has been updated and (coding wise) simplified. 
- Server Settings; online servers can now have individual settings. The amazon
  server can now be configured to retrieve user reviews (or not). 
- Web Server: Files are now downloadable links.
- Fields on the item form are now styled more appropriately.
- Added a summary tab (for new installations only) as the item form was getting a tad
  cluttered with fields.
- File privileges checks are now performed on the files in the distributions.
- <.SRT> will no longer be added as a language for movies (Movie File Import).
- A new field has been added to the software module: version.
- Three new fields have been added the book module: binding, edition type and
  edition comment. 

[New]
- Directories can now be marked as being drives. This is essentially a fix for non 
  Windows platforms. I would like to thank François Rey for supplying the code for the 
  'directory as drives' functionality.
- The software, music album, audio CD, book and movie module have 2 new fields:
  language and country.  
- Two new property modules: country and language.
- An additional movie report (List Report (xvids)) has been added. 
  This report is created by Ingo Macherius


-----------------------------------------------------------------------------------------
Data Crow 3.4.20 [Release on 13/09/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
CANCELED. Contains most of the fixes as part of the 3.5 version but was canceled shortly 
after its release due to technical problems. 


-----------------------------------------------------------------------------------------
Data Crow 3.4.19 [Release on 09/09/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Locking issue. The HSQL engine has been upgraded to the latest version. 
- Reports for audio CDs now contain the genre(s).
- PDF front page not added when using 'Attach File Info'.

[New]
- A new parameter has been added: -debug.


-----------------------------------------------------------------------------------------
Data Crow 3.4.18 [Release on 07/09/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Black image backgrounds for icons of new modules (now transparent).
- General Field Settings: the field names are always displayed in English.  
- The application crashes when closing the 'select language' dialog without using the 
  buttons 
- Item is not removed from the new items tab when saving it from within the item form.
- Quick View is now updated when a related item has been changed.
- The grouping pane does not update when the name of, for example, an artist has changed.
  (movie module > group by artist > change artist name = not reflected in the grouping 
  pane).
- Incorrect lower and upper case sorting in the grouping pane.
- 'languages.properties' not found message on startup on non Windows systems.
- Sample image not loaded on new installations (non Windows systems).
- Item Import Wizard: changing the separator character has no immediate effect. 
- When there are no reports for a module the reports menu option will not be available 
  anymore.
- The main form's locations is now remembered. Other dialogs and windows are placed in the 
  center of this form. This fixes the dual monitor issue.
- Images not saved when saving new items from the table view.
- Child records were not removed from the cache.
- The item form for music albums and audio CD sometimes incorrectly mentions that there
  are unsaved changes.
- Several minor problems with the table view in when used for saving new music albums, 
  imported by the file importer.

[Changed]
- Additional information when importing items.
- Non digits are now removed from the search string when performing an online search
  using an ISBN number.
- You can now also create a report for only the selected items.
- XML and XSD files are now removed after a report has been created.
- After entering an ISBN in the online search form the ISBN search mode will automatically 
  be used.
- The user reviews have been removed from the Amazon search.

[New]
- Version check on startup. The version check can be disabled.


-----------------------------------------------------------------------------------------
Data Crow 3.4.17 [Release on 25/08/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
A small release containing minor changes and fixes only. 

[Fixed]
- A possible cache mechanism error.
- The CSV importer did not allow fields to be mapped. Furthermore it did forget the 
  mappings while navigating back and forth through the wizard.

[Changed]
- All windows now have the following shortcut keys (if applicable):
  (S)ave, (C)ancel, (C)lose, R(un), (O)k, A(pply), (N)ew, N(ext), 
  (D)elete, (A)add, C(lear), S(t)op, S(tart), (Y)es, (N)o, (R)emove, (B)ack. 
- Some dialogs and buttons will now have new icons.
- IMDB movie search has been improved to ensure future compatibility. The old 
  implementation did not always deal well with the HTML formatted text and the localized 
  versions of this wonderful site.
  

-----------------------------------------------------------------------------------------
Data Crow 3.4.16 [Release on 18/08/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
Another day another version. Unfortunately the Amazon service API was changed just after 
I released yesterdays version. 

[Fixed]
- Amazon service does not work anymore.


-----------------------------------------------------------------------------------------
Data Crow 3.4.15 [Release on 17/08/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
Apologies for the previous version. Somehow I managed to release a version based on the
wrong source tree which resulted in a corrupted Item Form.

[Fixed]
- Tabs could not be created.
- Tab order not remembered correctly.
- Children of items were not imported (XML import).
- The table view did no longer work correctly for parent <> child modules 
  (multiple issues).
- Categories and other properties could no longer be created.
- Long play lengths are displayed incorrectly in the quick view and in the reports.


-----------------------------------------------------------------------------------------
Data Crow 3.4.14 [Release on 16/08/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

! Due to maintenance the upgrade process has been removed. This means that old
  backups cannot be restored within this version (3.4.12 and older). Sorry for any 
  inconvenience caused by this. 
! The startup time has been significantly improved by this version.

[Fixed]
- Table view fix: images were never displayed after adding them to an existing item.
- [2837111] Long play length is displayed / saved incorrectly

[New]
- Item export wizard. You can now export any items form any module to a text or XML file.
- Item import wizard. You can now import items for any module from a text or XML file.

[Changed]
- Increased startup speed (15 to 20 seconds faster).
- Improved opening time of item forms (3 to 5 seconds faster).
- The migration tool has been removed. This tools has been replaced by the new wizard(s).
- The right-click menu in the item views now offers the option to export the selected 
  items.
- The reporting dialog no longer offers the option to make an XML or CSV 'report'.
  This functionality has been replaced by the item export tool.
- When using the add item button from the item form will not only create the item but
  also set it on the field.
- Indentation for text in the grouping pane has been adjusted. 
- Text color for selected tree nodes has been set to black.
- Better indentation in the table view.


-----------------------------------------------------------------------------------------
Data Crow 3.4.13.2 [Release on 03/08/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Edit as new for users: when using this functionality the user is not created correctly.
  The functionality has been removed for the users module.
- The view is not populated (at all) when the grouping pane has been disabled.
- Directories cannot be opened by the File Launcher.
- [2788061] NPE while external images insert/delete.
- [2825152] Not all files are imported (File Import > Books). The error handling has
  been improved to catch out of memory errors (which can occur when dealing with large
  files).
- [2790438] Filename cannot be cleared. You can now right click on the file field to  
  clear it.
  
[Changed]
- Double clicking on the file field will now open the file / directory.


-----------------------------------------------------------------------------------------
Data Crow 3.4.13.1 [Release on 26/07/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
This patch fixes a couple of issues related to the mass update and the file 
import functionality.

Extract this patch to the installation folder of data crow, overwrite the existing files.

[Fixed]
- MKV files locked by the music file import process (fixed in the Matroska third party
  library).
- Import of e-Books gets stuck when importing a large amount of files.  
- NullPointerException during music album import in combination with an online service.
- ProgressDialog enters infinite loop on disconnect.
- Error while removing an item: 
  java.lang.IllegalArgumentException: node does not have a parent
  

-----------------------------------------------------------------------------------------
Data Crow 3.4.13 [Release on 25/07/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Icons for multiple reference fields are not shown in the tree / grouping pane.
- Removing an item did not remove all the empty paths from the tree / grouping.
- The mass update feature failed to retrieve / update multiple reference fields 
  (like artists, authors, publishers).
- Improved the error handling of the import (exception hiding issue).

[Changed]
- Column widths are now remembered.
- The Look and Feel settings dialog now allows you to set the table row height and the
  tree node height. This dialog already allowed you to change the look and feel and set
  the button and input field height.
- 'Number of pages' is now retrieved from amazon.
- Changed the icons for the file structure tree.  


-----------------------------------------------------------------------------------------
Data Crow 3.4.12 [Release on 19/07/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- File tree view sometimes showed an incorrect path structure.
- Building a new chart will no longer lock the GUI.
- Building the File System Tree will no longer lock the GUI.
- Deleted items were not removed from the file tree view.
- New items were not added to the file tree view.
- Software Import in combination with an online service sometimes failed 
  (rare occurrence).
- The grouping pane sometimes failed to add an item (rare occurrence).
- Several mistakes in the Dutch translation.

[Changed]
- The File Structure tree now shows the correct file system structure and
  indicates whether the file or directory actually exists.
- 'Locale Settings' has been renamed to 'Regional Settings'.


-----------------------------------------------------------------------------------------
Data Crow 3.4.11 [Release on 10/07/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
This is a maintenance release fixing several issues for the mass update and the drive
manager functionality.

[Fixed]
- Mass Update did not use the overwrite field settings correctly. Additionally values
  were cleared.
- Changed labels for fields caused the sorting dialog to stop working correctly; 
  empty field shown in the field selection.
- Drive Manager File Synchronizer was not working correctly. The matching process has
  been improved.

[Changed]
- Mass Update: A new option is available "Use original service settings". When enabled
  the original settings as stored in the item. Only items having service information set 
  will be updated. This was, somewhat, the default behavior in the past which caused 
  confusion. By default this option is "off".
- Code review: Synchronize (mass update) classes have been simplified.
- File Import: the dialog now shows the volume names as well as the drive letters.
- Drive Manager: changes have been made to improve the performance dramatically.


-----------------------------------------------------------------------------------------
Data Crow 3.4.10 [Release on 17/06/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
I'd like to thank Pierre-Yves  for his contributions.
This new release contains minor new functionality and fixes.

[Fixed]
- File importer sometimes fails when removing words from the filename.
- The File Types dialog for the File Import dialog was too small and didn't have a title.

[Changed]
- Book file import now reads the first page of a PDF and sets this as the front picture.
- The image importer now also supports SVG files. Note that for existing installations
  you will have to add the SVG extensions to the File Types filter of the import dialog.
- Added a cancel button to the quick filter bar.


-----------------------------------------------------------------------------------------
Data Crow 3.4.9 [Release on 14/06/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
I'd like to thank the following contributors: Marco Artioli, Mathias Epp and 
Tomáš Polomský.

[Fixed]
- Preventing a thread lock on startup for Linux systems related to the language selection
  dialog. Code donated by Tomáš Polomský.
- Experience mode was nor remembered when selecting the expert user mode.
- The selection of field in the item form settings dialog caused the lists to resize
  with every selection.
- The XSL (stylesheets) were called XLS in the backup and restore interface.


-----------------------------------------------------------------------------------------
Data Crow 3.4.9 [Release on 02/06/2009] [testing: moderate] [target: beta]
-----------------------------------------------------------------------------------------

[New]
- Italian translation! Thanks to Marco Artioli!
- Updated german translation! Thanks to Mathias Epp!
- Data Crow's web server can now be started without showing the UI. The normal parameter
  'webserver' in combination with the new credentials parameter hides the splash screen 
  and bypasses the login dialog. See the readme on how to apply these parameters.
- The item form has it's own settings dialog. From here you can define tabs (such as 
  the current information and technical information), assign fields to tabs and set
  the order of the fields. The general field settings has lost the ability to set
  the field order as this was only used by the item form.
- In the previous versions the uniqueness of an item was determined by checking the
  combination of the required fields. Now this behavior can be managed by marking fields
  as key fields. By default, none of the fields is marked as a key field. 
- The file importer considered a fixed set of file types. The functionality has been 
  expanded to allow the user to define additional file types.
- Icons are now shown in the tree view.
- The alter module wizard now allows for fields to be changed as well. Upgrades are managed
  automatically.
- You can now map a drive letter / location to a new location. Settings > Drive Mappings.
- The help now has search capabilities.
- The mass update functionality now supports all search modes.

[Changed]
- The default view can now be set per module. In previous versions this was a global 
  setting.
- Error handling for the file importers and the attach file information has been 
  improved.
- Containers can now have an icon assigned.

[Fixed]
- NullPointerException when clicking in an empty space of the field selection dialog.
- Error in the settings: long stored as integer.
- Unused columns, due to conversions in the past, will now be removed.
- NullPointerException when trying to use the Bol.com online search.
- Tracks were duplicated after updating an audio CD imported via the 
  'retrieve CD information' tool. 
- View not updated properly when switching between view types (without grouping).


-----------------------------------------------------------------------------------------
Data Crow 3.4.8 Patch 3 [Release on 04/03/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- [2576366] "AWT-EventQueue-0" NullPointerException after restoring a database.
- [2580766] Update all issue (screen locks when trying to add a new container).
- [2582797] JTatoo errors under JDK 1.6.0_12 (modified the JTattoo distribution, third
  party coding).
- [2617165] NPE during IMDB movie import
- Due to the check for Java version Data Crow does not run on Mac systems anymore.
  The check has been changed to a warning (which will only be shown once) after 
  which Data Crow will (try to) start normally. 


-----------------------------------------------------------------------------------------
Data Crow 3.4.8 Patch 2 [Release on 06/02/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Bol.com book search did no longer work in combination with author information retrieval.
- Updated images disappeared (rare occurrence).
- Author information was not retrieved for the Barnes & Nobles online search.
- Year not always retrieved for Imdb.com (errors).
- Alapage did no longer retrieve detailed information.
- Create module wizard shows a label "table name".

[Changed]
- Added new command line option: -nosplash. This option hides the splashscreen.
- Updated German language! Thanks Linux!


-----------------------------------------------------------------------------------------
Data Crow 3.4.8 Patch 1 [Release on 26/01/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Fixed the reporting for the movie module.
- Fixed a startup error related to the languages.


-----------------------------------------------------------------------------------------
Data Crow 3.4.8 [Release on 25/01/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Changed]
- Updated the default settings.
- The music album importer now also reads the artwork information from MP3 files 
  (cover images).
- Images can now also be added via the menu option 'Add From Memory'.
- Check on startup for the Java version (Java from Sun must be used).

[Fixed]
- Reporting for PDF does not images and/or fails completely.
- Music importer stopped processing files not containing any tags. 
- Screen refresh errors in the module wizards; wizards are unusable.
- Fixes on the Dutch translation.
- Fixes on the French translation.
- Removed hardcoded text.

[Components]
- Downgraded Apache FOP to version 0.94 (libraries used for report generation).
  Downgrading was needed because of a known issue with the image handling.
- Updated jaudiotagger to version 1.0.9.


-----------------------------------------------------------------------------------------
Data Crow 3.4.7 [Release on 08/01/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Changed]
- French translation has been updated (thanks Pierre-Yves DANTEC).

[Fixed]
- Picture fields column can not be added to the table view. 
  In previous versions this was possible.
- [2485347] Malformed URL syntax for pictures break reports. 
  Pictures are not correctly added to the reports (since Apache FOP 0.95). 
- [2464760] Inability to work with Cyrillic author names 
  Filter dialog allowed free form input for multi-relation fields 
  (which is not supported).
- [2487958] Report sort order after import 
  Items are not always correctly sorted when added to the reports.


-----------------------------------------------------------------------------------------
Data Crow 3.4.6 [Release on 02/01/2009] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
Due to the overwhelming response and complaints about having to set the DATACROW_HOME
directory or to supply the -dir: parameter I have decided to change this with this early
release. Oh, and there's something new as well; a French translation! Big thanks to
Pierre-Yves DANTEC!

[New]
- French translation, with many thanks too Pierre-Yves DANTEC!

[Fixed]
- NullpointerException when closing the user form.
- Help cannot be shown.
- Service information is not set.

[Changed]
- Data Crow will now try to determine the installation directory itself. If this fails
  it will fall back on the DATACROW_HOME environment variable or on the -dir: parameter.
  The environment variable and -dir: parameter overrule this behavior (if supplied, these
  will be used instead). Many users had problems with specifying the environment variable
  and this changed is meant to take the pain away.  


-----------------------------------------------------------------------------------------
Data Crow 3.4.5 [Release on 31/12/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- File renamer does not work for the music album module.
- Online update with only picture fields enabled does not allow to save the updated item
- Incorrect Dutch / English translation resulted in incorrect action when closing an item 
  form with unsaved changed (lost in translation..).
- Create multiple should be limited to properties and audio tracks only.
- Data Crow is not always successful in finding its installation directory (see changes);
  Especially on Vista and Linux platforms.
- [2463925] Vista - Incorrect folder permissions
  Data Crow does not report anything when the folder permissions are not set correctly.
  This results in loss of data (Linux, Vista).
- [2461042] Crash: opening card view after changing item in table view.  
- Headers of tables were not translated.
- Loan information panel was not translated.
- Log file is created in a separate data folder.
- Music Tracks are not added when performing an online update.

[Changed]
- It is now mandatory to set the DATACROW_HOME system environment variable or to supply
  the -dir: parameter. 
- You can now add new items to list boxes from within the item form (categories, etc.)
- Picture fields now have the ability to rotate image (see the edit menu).

[Components]
- IZPack (installer) has been updated (4.2) to the latest version. The latest version 
  allows the users to select the correct user when installing Data Crow.
- Image4J has been removed.


-----------------------------------------------------------------------------------------
Data Crow 3.4.4 [Release on 20/12/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
The code has been reviewed and many small improvements have been made. As a result
of this, this version uses less memory and has once again an improved start up time.

I have been working quite hard to get the code documented. The emphasis for this release
is again.. quality! I was quite happy with the stability of the 3.4.3 version but not
with the amount of fixes needed to get there. 

Please note that a new version of the web module is available (version 1.2). This module
needs to be installed on top of Data Crow in order for the web module to be available.

I would like to thank Klaus Lassleben for his German translation of the labels!

[New]
- Multiple languages support. The language can be selected in the locale settings from 
  the settings menu.
- New languages can now be created from within the resource editor. Fields and modules
  can now also be translated from within this form.
- German language has been added (created by Klaus Lassleben).
- Dutch language has been added.

[Fixed]
- [2334235] Over due bug. 
  Loan administration shows items with a due date for the next year as overdue.
- [2338017] Missing horizontal scroll bar. 
  The quick view does not have a vertical scroll bar.
- [2392326]Locked out of Database after creating a backup.
- Nothing happens when selecting 'launch file' after adding a new file launcher field 
  to a module (in this case the music album module).
- Music Album and Audio CD report (Black&White) did not generated successfully.
- Users created using the item wizard cannot log into Data Crow. The wizard will now start
  the item form itself.
- A check has been added to see whether Data Crow does have write permission on the 
  database files.
- When the item form asks "there are unsaved changes" and you answer "no: on the question if
  you are sure you want to close the form it's closed anyway.
- Cannot translate module names + field names using the resource editor.
- Cannot translate settings.
- Removed most of the not used messages and labels. 
- Hardcoded labels and messages.
- Descriptive setting was not remembered (field settings).
  Bug in the version check caused the settings to be converted on each startup.

[Changed]
- The web server can now be started from the command line without starting the Data Crow
  application. The parameter to use is: -webserver. The server can be brought down 
  gracefully using the CTR-C command (as displayed in the console).
- The display format for person names can now be set using the settings dialog.
  (Settings > General Settings > 'Default display format for the persons name').
- UTF8 support for resources (labels, messages, etc).
 
[Components]
- Updated Jetty to the latest version (6.1.14)
- Updated FOP from Apache to version 0.95 (Libraries used for report generation).
- HSQL DB has been upgraded to version 1.8.0.10


-----------------------------------------------------------------------------------------
Data Crow 3.4.3 [Release on 08/11/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Changed]
- Button height can now also be set via the look and feel dialog.
- Containers now can hold a description.
- The item wizard will now ask to select a container when started from the container 
  module.
- The item form will now set the first text field as selected.

[Fixed]
- File launcher does no longer launch filenames containing a space character 
  (replaced by %20).
- Non admin users cannot save items after changing the multi-relate field.
- Field ordering in item form of the web module does not depend on the web field settings.
- Cannot edit the multi relate fields using the web module.
- External links do not work in the web module.
- New user cannot login after logging in once.
- Update all does no longer allow updating fields like artists, developers, etc.
- User mix up when multiple users are logged on (web module).
- Field heights not correctly applied to all fields (such as the settings dialog).
- Nimbus L&F errors. This L&F has been disabled for now.
- Data Crow can become very sluggish when too less memory has been allocated. Data Crow
  now reports memory problems back to the user and offers the solutions for the problem.
- Sorting issues for persons in the tree panel and the references dialog.
- "Perform a search first" message in the item wizard when pressing enter in the online
  search step.
- Nullpointer exception when closing the module selection for the item wizard in abstract
  modules.
     

-----------------------------------------------------------------------------------------
Data Crow 3.4.2 [Release on 02/11/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Changed]
- The online search has been changed and optimized:
  * You now have the option (default) to retrieve only a minimum of information for each 
    item in the initial search. The item details will be retrieved on request / once the 
    item has been selected. Ticking the box 'retrieve full details on initial search (slow)'
    will activate Data Crows old behavior.
  * Improved speed for the Mass Update of items.
  * Improved speed for the Item import when using the Online Services option.
- Added '-help' parameter which displays information on starting Data Crow in a dialog.
- Changed the height of the input fields (21 to 25). The field height can now also be changed
  from the Look and Feel Settings Dialog.

[Removed]
- Bol.com search has been removed. This search engine is awaiting a new implementation.
- Wikipedia search has been removed. This search engine is awaiting a new implementation.

[Fixed]
- Incorrect upgrade proposals on startup.
- Service URL not set by some online searches
- Setting value without override of existing value fails even if the current value is
  empty.
- First name is set as last name and last name as first name (all person modules).
- Sorting does no longer work (only string values work). Empty values seem to be the 
  cause of this malfunction.
- Cannot re-active module as it is no longer displayed in the module settings.
- Update all does not work with actors (and so on) (updated in DB but not in UI).
- Quick filter no longer displayed in the book module.
- Import of some images does not work! (meta information read exceptions not caught)
- Add picture field to existing module > items are not opened in item form. 
  Caching issue: always clear cache if the module has a new field.
- After altering a module the old cache is still used.
- Old cache is used after an ungraceful shutdown. 
- Picture not shown in the card view (view settings does not see the new picture fields).
- Container field can be updated using update all.
- Templates issue; sub menu for new using template is not there after a restart.
- Pressing escape causes Data Crow to exit without further notice, even when there are
  unsaved changes.
- In debug mode the message for which module is being registered does not always contain
  the module name.
- The resource editor no longer allows editing system labels and such.
- Parameter information missing in the readme file.
- ClassCastException when opening items from the table view after double clicking on a 
  non-string field.
- Incorrect "Item changed has changed message" when opening items from the table view 
  after double clicking on a non-string field.
- UI only fields and read only fields could be marked as required in the field settings. 
- Message in log file: "ERROR [Thread-19] (ComponentFactory.java:187) - Not thread-safe; 
  should only remove components from within the Event Dispatching thread". Cause has been
  fixed.
- Items for custom property modules do not show anything in the related items tab.
- Errors when trying to start with a different user on an upgraded database.
- Altered modules with a reference to a newly created property module fail to load and
  give startup errors.
- Fixed several issues with permissions and newly created and altered modules.
- Label for newly created Media Modules is always empty.
- Items from newly created modules, used within another module, show all items of the
  parent module in the related items tab.
- Filter uses .toString() to search for corresponding items instead of the ID of the 
  item.
- File size columns are of type INT and should be BIGINT. This conversion will be done
  without further notice.
- All GUI number fields were still bound to the maximum value of an integer.
- Connection errors while retrieving items from MusicBrainz.com.
- IMDB Person search: ArrayIndexOutOfBoundsException -1.
- New module icons have a black background instead of being transparent.


-----------------------------------------------------------------------------------------
Data Crow 3.4.1 [Release on 27/09/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
This release upgrades the existing loan functionality. A due date has been added and the
loan information can now be viewed in a specialized dialog.
Items now show which items are using them; actors have a separate tab to show in which 
movies they have performed.
The FreeDB support has been re-added. It was present in older version and has now be 
delivered as a separate plugin (with limited support).
The tools menu has been split into an administration and a tools menu. The administration
menu can be used to maintain genres and the likes and to view the loan information.

[Fixed]
- Nullpointer exception after lending an item (quick view panel is cleared).
- [209920]  Unable to log in except in admin. 
  Preventing a null pointer exception (and the consequences) during startup.
  (Unconfirmed fix).
- [2083958] Error after adding a new field.
  Added new rules for module creation and alteration.
- [2029808] F8 only works when module pane has focus
- Days lend was not correct. It should be recalculated on startup.
- "Lend by" was not correctly filled (empty in view).
- Renamed "Loaned by" to "Lend by"
- "Is Empty" operator (used for filtering) was broken.
- Dates not always displayed in the correct format in the table view.
- Sample item (Data Crow) was not loaded on startup.

[Changed]
- Contact persons can now be deleted after they have lend and/or returned items.
- Containers can now also be created from within the import dialog.
- Container view is now able to display the items directly from the grouping
  pane. The table view has been removed (obsolete for this module).
- Loan management, Due Date (1941130)
  Due date for loans. A due date can now be specified. A dialog has been added
  to show the statuses of loaned items. The overdue date can also be used in views.
  Two new fields are now added for each items: Date overdue and days till overdue.
  These fields can be used for filtering, etc.
- A new menu has been added called administration. This menu contains the 
  manage X menu items and the new loan information menu item.
- [1997333] Name order for authors and publishers. The general settings now
  contains option for the sorting of persons. The selected setting also effects
  the way the item is displayed. 

[New]
- The item form now show related items (in a separate tab)
- The item form now displays lend item information for contact persons
- A new dialog has been created which shows the current lend items, ordered by due date.
- Overdue items are displayed in red in the views.
- Quickly create multiple items such as audio tracks, music tracks, genres, 
  categories, .. by using the 'Create multiple' option. 
- New Field: Days till overdue
- New Field: Due date
- [2069192] FreeDB and CDDB support 
  Audio CD's inserted in the first drive of the system can now be read and information
  can be retrieved from Freedb.org. The tool can be found in the tools menu, 
  "Retrieve CD information". This functionality was present in older versions of Data 
  Crow (2.12) and was removed as it could no longer be supported. I have added the 
  functionality as a separate plugin. No additional support will be delivered for 
  this tool.


-----------------------------------------------------------------------------------------
Data Crow 3.4.0.1 [PATCH]  [Release on 08/09/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
This patch fixes the loan functionality.

[Fixed]
- [2100120] Lost "LoanedBy" movie.
- [2099205] Unable to check books in.
- [2089573] Incorrect layout of the File Import screen.


-----------------------------------------------------------------------------------------
Data Crow 3.4      [Release on 31/08/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
This version comes with new functionality, fixes and an improved upgrade process.
The improvements of the upgrade process are mainly due to the new version management.
When upgrading a warning will appear stating that the version of your database or
backup could not be determined. As long as you follow the upgrade paths it is safe
to ignore the message. After the first startup this message will no longer appear.

[New]
- Online services are now plugin based. Additional plugins can be delivered as jar 
  libraries which can be put in the services directory. The online services are no 
  longer bound to software version deliveries and can be released separately. 
  Data Crow will come however with a default online services pack.  
  Plans have been made to allow automatic updates.
- Clickable links in the quick view and the item form for faster navigation to 
  sub items (such as actors for movies)
- Container module. The location field has been replaced with a container field. 
  A container can be anything such as a CD, a CD box, a closet.. anything. On startup you 
  will be prompted to convert the locations to container items.
  This module will be expanded in the near future.
- File structure tree.

[Changed]
- Code review: filter operators rewrite, music album importer code reuse issue.
- Removed the following message box: "save succeeded".
- Removed the following message box: "no items have been found for xx" when searching for
  an item.
- The online search form will no longer close after adding a new item or updating an 
  existing one. It will now add the item(s) and clear the form. This allows users to do
  multiple searches without having to re-open the form every time. 
- Replaced Entagged with JAudioTagger for parsing information from music files.
  JAudioTagger has continued on the work of Entagged 
- Version numbering is no longer dependent on the settings file. The version is now kept
  (in a structured way) in the database.
- New backups now contain a version number. This will be used to check if a backup can
  be restored in the current version.
- Restoring an backup of an older version will now cause Data Crow to restart.
  A restore of a backup of the current version will not cause a restart. This has been
  changed to make sure older databases are correctly upgraded on startup. 
- Table view: removed line numbering. Removed horizontal grid lines.
- Settings views: removed line numbering.
- Quick view settings: added an option to set the background color. Removed the dependency
  of the background color towards the even/odd color of the view.
- View Setting: There were all kinds of dependencies towards the general field settings.
  Most of the option were not really clear. To overcome this each view has gained its very 
  own settings dialog. Everything for that view can be changed from there. Removed the 
  visible option from the field settings. Card view item description can now be set via the
  View Settings.
- Web Field Settings: Removed the dependency for the quick search fields towards the 
  general field settings. The web field settings now contains the option to use a field as a
  quick search field.
- Removed the question mark images for missing covers.
- caching of items to improve startup times. Instead of creating all the data sets on each
  startup the data sets are now written out to disk on shutdown and reloaded on startup.
  When upgrading or restoring a backup the cache will be ignored and the data sets will be
  recreated from the database (which is still the leading data store).
  Additionally, if needed for any reason), Data Crow can be started without using the cache
  by adding the parameter -nocache. Startup times are improved by 20% due to this change.
  The first startup however will still load the items from the database.
- Before and after for Dates
- Picture settings have been added to the Card View Settings. The shown picture no longer
  depends on the general field settings.
  
[Fixed]
- Sometimes items are not added to the view after a different node in the grouping pane
  has been selected.
- Database collation was incorrect by default causing Chinese characters (and others) to 
  be stored incorrectly. This is only fixed for new installations.
- Faster image loading for the card view. It now uses less memory and has a better
  performance.
- [2039920] "Update all" empties fields
- [2039948] Save from "online search" issue
- [2032102] Threading issue with saving IMDB movie actors
- [2027395] Incorrect label for "manage states" (music album/track)
- [2030645] Front picture not shown in card view (sometimes)
  Empty images are stored causing empty pictures to be displayed (incorrectly fixed in
  the beta version).
- [2029825] Updating old record empty fields doesn't work
- [2029628] Online update on actor inside the movie module fails
- [2029637] Can't cancel changes
- [2034988] Can't re-attach Quick filter widget
- [2039939] "update all" not fully applied (view changes)
- [2005182] Initial Start Up
- [1995128] Upgrade error
- [2055353] Uncaught NPEs
- [2063861] Very Slow, uses 100% of CPU. 
  The startup time for databases containing a high number of items (20.000+) has been
  increased dramatically (from minutes to seconds). Additionally a caching mechanism has
  been introduced which further improves the starting time by about 20% on a seconds run.
- Screen lockups. Threads were running with a maximum priority causing them to get a higher
  priority then other Windows threads. This caused Data Crow to become inresponsive.
- Message box is sometimes shown on the wrong form causing the current window to loose 
  its focus.
- Pressing escape in the mainframe bypasses the check for changes.
- Incorrect message when exiting Data Crow.
  Changed the message to "There are unsaved changes. Are you sure you want to exit?"
  when exiting Data Crow.
- Fixed several possible startup issues for Linux platforms. (preventing messageboxes
  to block the screen while the splash screen is being shown).
- Fixed non fatal nullpointer errors on startup. 
- Version number was not written to the settings file making it unusable for future
  reference (upgrading).
- Messages for upgrades were not in the center of the screen.
- Improved error handling for the upgrade processes. Better information and warnings
  when the database is of an older version.
- After removing the properties/settings file the system asks to perform unwanted 
  upgrades.
- Continuous scrolling in the card view, online search and manage item x forms.
- When hiding the grouping pane all views are re-filled. This makes Data Crow very 
  slow and does not abide to the standard behavior. Only the views of the current 
  module should  be refilled. 
- Incorrect display of the module permissions (user form).
- Deleted child items still shown in the view.
- Nullpointer after closing the image editor.
- Navigation buttons for the field settings, quick view settings and the web field
  settings were incorrectly aligned.  
- Tabs are hard to distinguish.
- Discogs: images not retrieved.
- Discogs: for some albums empty tracks are added.
- Performance bug when filling a view with items with children.
- Button alignment for the question message box (yes/no). 
- ISBN 10 calculation was incorrect.
- Starting a file import multiple times results in the previous items to be added
  to the new tab again. 
- Barnes & Nobles online search did no longer recover the title.
- Old items are loaded when restoring an old backup. Cache should be cleared after
  each restore. 
- Query error when searching for titles (etc) containing a ' character. 
- Created and modified date were stored as strings making it impossible to create 
  filters (like before and after) on them.
- Incorrect filter operators for numbers and dates (contains, etc).
- (Beta bug) reports still contained the location field (changed to container)
- Adding a new module does not load the new items (cache should not be used)
- Nullpointer in the File Renamer.
- Music Album importer creates empty albums.
- Memory leak in the image import. 


-----------------------------------------------------------------------------------------
Data Crow 3.3      [Release on xx/06/2008] [testing: moderate] [target: production]
-----------------------------------------------------------------------------------------

[New]
- This version supports the web module (which has been released at the same time of 
  this version). The web server can be found (after the web module has been installed)
  in the web server menu.
- Bol.com movie search (Dutch titles).

[Fixed]
- Typos in messages
- Right-click in the view changes the selection incorrectly. 
  Fixed by only changing the selection of no item has been currently selected or the
  selected item count equals 1.
- Update all did not work correctly due to the above mentioned bug.
- Scaled images were incorrectly stored. The format is not supported by external 
  applications. The upgrade process will ask to convert these incorrect images.
- The help text for the software item mass update stated incorrectly that a match is
  needed on both the title and the platform. Only a match on the title is needed. 
- Picture in the quick view disappears after double clicking it (opens the item form,
  after closing this form (without saving) the picture is no longer displayed).
- Exit of Data Crow after a restore (without any warning). The restore was however
  successful.
- Hash calculation consumed too much memory. Replaced with JackSum functionality.
  The maximum file size (for performance tweaking) for hash calculation can be set.
  Default has been set to 40MB. 
- Wrong item form is opened (example: user) when double-clicking on the quick 
  view panel.
- NullpointerException: Media module > Create New > Make no selection / close dialog.
- Incorrect default settings (fix for new installations only). 
- Chart tab is displayed for developers / actors /.. while no fields can be selected.
  Chart tab should not be visible for these modules.
- Fixed a bug which caused the 'Attach file information' function to crash on very 
  large files (2GB +).
- Buttons not fully displayed in the settings view.
- [1958448] Same field can be created twice using the module wizard. The second field
- Better cleanup of garbage from titles for imported items.
- File launcher field tries to launch an empty file (NullPointerException).
- Directory usage of the music file import did not work correctly for every situation.
- Local Art dialog misses help text.

[Changed]
- Mass update now allows to update either all items currently shown in the view or
  the currently selected items.
- The hash calculation can now be set in the settings dialog. Supported hash types
  are: EDK, MD5, SHA1, SHA256 and many, many others. The hash and the hash type are 
  stored for every item.
- Online Search for the importer now always checks for a perfect match.
- File import file / directory selection has been changed.
- File import dialog has been re-designed.
- WMA support has been enabled for the music album module.
- All person modules gained a first- and last name field. These fields will be 
  automatically 'calculated' on first startup. The old name fields now serve as 
  full name fields and are left unmodified. 
- Added EAN field for software, audio CDs and movies.
- You can now enter words to remove from the title when importing files. 


-----------------------------------------------------------------------------------------
Data Crow 3.2.2.1  [Release on 05/05/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Incorrect layout for the quick view panel (comma characters are replaced by newlines). 
- The tree panel does not sort the leafs correctly for fields like genres.
- View is refreshed after an update. (only happens when the highest node in the tree
  view is selected).
- Improved startup time (performance change/fix).

-----------------------------------------------------------------------------------------
Data Crow 3.2.2  [Release on 04/05/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
Performance has been increased and again some important bug fixes. The main changes are
in the file import; local art can now be imported and all file importers can now also 
perform an online search.

[Fixed]
- Incorrect font used for the module settings.
- Incorrect image displayed in the list view.
- Table view, new item tab, does not preserve the images. The image gets unloaded when it
  is added to the view. Also its status is erased.
- Incorrect icon for the login dialog.
- Removing rows from the new item tab fails (sometimes).
- Incorrect normalization; when searching for "Stargate the Ark of Truth" it is normalized
  to "Stargateark of Truth".
- Operations on the tree panel were performed multiple times (performance bug).
- QuaQua look and feel does not work with the Data Crow layout. This look and feel has
  been removed.
- Movie synchronizer does not work.
- Right click does not select the item in the view.

[New]
- Platform change: on database initialization columns lengths are now checked against
  the module definition and changed accordingly. (Text fields only).
- Experience modes: Data Crow now features a beginner and an expert user level. This allows
  new users to start of with a fewer option allowing them to focus on the basics of 
  Data Crow. On startup you will be requested to select your own experience level.
  At any time you can switch to an alternate user mode (no restart required). 

[Changed]
- Rewrote the code for the Tree Panel (TreePanel). It was overly complex and the initial
  build of the tree was too slow. The new tree is about 90% faster which shortens the
  startup time for Data Crow. 
- Improved grouping; it is now possible to group on more then 2 fields (levels), 
  creating a multilevel overview of your items. Any field can now be selected. 
- Maximum length for Description fields (and other long text fields) has been increased
  to hold an (almost) unlimited amount of characters.
- You can define the maximum text length for each field displayed in the quick view.
- Better handling of text in the quick view. Enters are now preserved. 
- Improved the handling of MKV files (Matroska) for the movie file import.
- The music file import had the ability to perform an online search during the import. 
  The other importers, such as the movie file import, did not have this ability. 
  All file importers now allow to use the directory information and are capable of 
  performing an online search.
- File import now uses the art present in the import folder. Using a settings dialog
  you can specify if to import local art and which keywords the art files should contain. 
  (Art means local JPG or PNG files which come with downloaded movies, mps's and software).


-----------------------------------------------------------------------------------------
Data Crow 3.2.1.2  [Release on 29/04/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
Thanks to mjgraf, m.bowwarrior and cascadeprincipes for getting me the nitty gritty
details I needed to fix the following bugs:

[Fixed]
- [1952703] Help does not show when using the menu option 'Help'.
- [1952705] Grouping Pane issue, empty list. Grouping pane looses items after an undo.
- Could not log in on non Windows platforms. Login dialog would not show and Data Crow
  would not start.
- A warning is shown each time the image editor is opened on non Windows platforms.  
- Administrator did not have the ability to reset / change the password of existing or
  new users. An option "set password" is now available from the right-click menu 
  (User module > select user in view > right-click > select "set password").
- Disabled user fields for new installations (can be enabled via field settings and
  should always be disabled for new installations).
- [1929426] Empty audio CD report and no error shown in log / on screen 
  No error shown when report creation is unsuccessful.      


-----------------------------------------------------------------------------------------
Data Crow 3.2.1.1  [Release on 25/04/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Error while trying to open a newly imported movie item from the table view.
- Incorrect sorting of numeric values.
- NullpointerException when not defining all the fields in the migration tool.
- More then two fields not being mapped in the migration tool gives a warning about
  duplicate mappings.
- The migration tool always treated the input file as UTF-8 which is for some cases
  incorrect. An option has been added to the dialog by which you can specify the 
  character set. The option is remembered for later runs.
- The migration tool could not be canceled. A cancel button has been placed on the form.
- The cover search for amazon did not pass the artist name; for most music albums no
  cover could be found because of this.
- Cover search for the MusicBrainz server did not work due to an recently no longer 
  supported cover search integration with Amazon.
- Image for new items not always shown.
- List view shows the incorrect image (performance, larger image is shown as necessary)
- ConcurrentModificationException when trying to delete a newly added music album / audio
  CD.
- Corrected spelling errors in the messages and labels.
  
[Changed]
- Added a search mode selection to the Mass Update to narrow the search.
- Mass update for Software no longer uses the platform in its comparison. 
- Improved the string comparison mechanism; improved Mass Update and Music File import 


-----------------------------------------------------------------------------------------
Data Crow 3.2.1  [Release on 20/04/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

[Fixed]
- Quick filter tool bar was unusable after selecting the rating field. 
- Incorrect help shown.
- Loan fields not displayed (available, etc) for non-admin users
- Permission fields like edit and view could be edited using the table view. These fields
  should not be edited using this view. Also they displayed as text (true/false).
- It was possible to add a new (invalid/meaningless) permission from the table view. 
- The login name field is now validated for valid input [a-z, A-Z]
- Icons could not be selected for new categories and genres
- Login dialog is displayed but the user cannot login. Currently the login dialog is always
  shown, even when the login credentials are correct but another error occurred when trying
  to log on to the database. Now, the availability of the database is checked first.
- Movies could not be updated using the online search.
- Errors after a restore (due to the newly introduced user management)

[Changed]
- You can now sort on genres, actors, etc.


-----------------------------------------------------------------------------------------
Data Crow 3.2.0.2 [Release on 30/03/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
The 3.2 release introduced some very serious bugs. This release resolves these issues.
The changes from the 3.2.0.1 patch are also included in this patch.

[Fixed]
- Picture fields and references fields were always disabled.
- Quick filter tool bar was unusable. 
- Loan fields are not shown in the quick view and in the view.
- Field enabling / disabling was broken.
- Newly created administrator cannot delete items.


-----------------------------------------------------------------------------------------
Data Crow 3.2 [Release on 24/03/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

NOTE: The first startup on an existing database will take longer then usual. The script
      format is changed. The conversion is, silently, done on startup. After the
      first startup Data Crow will run as fast as normal.

[New]
- Users can now create plugins. These will be available from the plugins
  menu and from the view popup menu. Plugin should be stored in the 'plugins' folder
  of the Data Crow installation. 
  A plugin must extend the 'net.datacrow.core.plugin.Plugin' class. The package name
  should start with 'plugins' (as the plugins folder is the base package).
  Additional jar files should also be copied to the plugins folder (or in any sub-folder 
  of this folder). These will be loaded automatically. Documentation will be created for 
  this feature.
- Security. Users can be created and assigned specific rights. Among these rights are
  field access (read/write), module access and plugin access.
- New online Spanish book search: MCU (http://www.mcu.es).
- New online German movie search: OFDB (http://www.ofdb.de).

[Changed]
- Code review: cleanup of online search classes. Removed code duplication. 
  Moved utility methods to the Utility class.
- Improved the performance for online searching. The HTML to Plain text conversion has
  been optimized.

[Fixed]
- [1894832] Cannot disable Contact Person module.
- [1896917] Quick Filter Field not enabled
- [1903029] Removing leading space in title not recognized as change.
- [1894851] ISBN search Barnes & Noble not working for ISBN 10.
- [1894839] Description window text partially covered by scroll bar. (Unconfirmed).
- [1879348] Online Search second ISBN hit uses results first ISBN hit 
  (Re-opened bug report)
- Module changes for contact person are discarded after a restart.
- Exception when saving a massive amount of music albums or audio CDs
  (CuncurrentModificationException).
- On closing an unmodified image a message is displayed stating the item has changed 
  while in fact it has not. This only occurs with imported images. 
- After an image import there are some items which do not have an image displayed 
  in the insert tab of the card view. After saving the image shows up in the item tab.
- Connection was not correctly closed by the amazon cover search.
  (unknown side-effects as these connections get closed automatically after a timeout).
- Small memory leak for the image retrieval done by the online search.
- Errors in log (non-fatal) 'Error while applying settings to column null for field 
  definition x' when the contact person module is disabled.
- No message displayed when nothing was found during an online search. This only occurs
  when there are already items present in the online search window from previous searches. 
- Strange characters in IMDB movie search for actor names.
  
[Known issues]
- Saving of new users takes a long time. This will be resolved in one of the next 
  versions.


-----------------------------------------------------------------------------------------
Data Crow 3.1.30 [Release on 12/02/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
The product is slowly recovering from the high impact changes of the 3.1 version.
This version again contains crucial fixes. Data Crow is slowly but surely maturing.
I have again chosen to create an in between release (this is the 3.1.30 version instead
of the 3.2 version) as I want you to benefit as soon as possible from these bug fixes.

There are also a few changes and new functionality to be found in this version. 
The File Renaming functionality is the biggest addition and is the first tool which 
manipulates data outside of Data Crow.

NOTE: 1 This version contains a database upgrade. 
      2 Create a backup before you install this version! 
        Use the 'backup & restore' tool from your old version.

[New]
- [1729965] File Renamer. Allows you to rename files (and even move them) of a module 
  based on information entered in Data Crow. This tool can also be used to move files 
  into a different directory structure (convenient for music files). The renaming is 
  based on a 'pattern' which can be created using the GUI. A preview is shown first
  before the actual renaming starts. he help has been updated to include this tool.

[Changed]
- [1886230] The rating system has been changed from a 5-based rating to a 10-based rating.
  All existing ratings will be converted to the new system; each rating is multiplied
  by 2. Online Searches have been updated accordingly. 
- [1885034] The File Import will no longer display a message box when a single file 
  cannot be parsed. Instead it will just log the error and continue with the next file.
- Added ratings to the MobyGames search result(s).
- Table headers are now styled after the selected Look and Feel.

[Fixed]
- Help does not show when the focus is on a (text) field.
- Entered text in the 'Text Dialog' (opened by double clicking on a large text field) 
  is not saved. A NullPointerException is shown in the log.
- Query errors in the log while saving imported Music Albums (no impact or data loss):
  "Attempt to insert null into a non-nullable column: column: ID table: 
  MUSICTRACK in statement [INSERT INTO musictrack (AlbumID) VALUES (?)]"
- Children are incorrectly added to the table insert view by both the Online Search
  and File Import functionality (all to one album).
- Mass update and the online search part of the Music Album Importer did not set the
  image(s).
- Uniqueness check for items was broken.
- Picture disappears when a newly added item is updated. The image was not deleted as it
  reappears after a restart.
- NullPointerException when opening item from the menubar while no item has been selected.
- Creating a new item from within the media module fails.
- Removing / Deleting an item from the media module uses the view of the 'actual module'
  instead of the current, media module, view. This causes another item to be deleted.
- Audio CD is not removed from the tree when deleted. A refresh of the view fixes this.
- Incorrect message being displayed when saving the selected audio CD from the table view
  (save > 'Do you want to save changes' > 'Yes' > Twice the message 'Changes saved').
- [1891575] Existing book won't update and can't close book window
- 99% CPU usage after performing an online search. Occurs only with the MusicBrainz 
  online search and is hard to reproduce. 
- Changes to the font are not applied on the menubar and the toolbar(s). Switching 
  between modules does update the font.
  

-----------------------------------------------------------------------------------------
Data Crow 3.1.25 [Release on 29/01/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------
This is an early release as the 3.1 version contained a couple of fundamental problems 
which could not be fixed by releasing a patch. This release also contains new 
functionality. A brand new tool, the Drive Manager, and two new online searches have 
been added, Alapage (a french book search) and Barnes & Nobles (an american book search).

I planned to add more features and online searches, but, unfortunately, stabilizing and
maturing the product needed more priority. These will be added to one of the future 
releases.

NOTE: 1 This version contains multiple database upgrades. 
      2 Create a backup before you install this version! Use the 'backup & restore' tool
        from your old version.
      
See the readme.txt file for upgrade paths for versions older then 3.0.

[Fixed]
- [1879348] Online search second isbn hit uses results first isbn hit
- [1878712] Software module is shown twice, Book module not selectable
- [1878652] Cannot close Data Crow
- [1855123] Wrong year when adding CD from MusicBrainz
- [1880118] NullPointer exception on startup
- [1876104] Updating bug
- Incorrect storage of cross table values for music artist and music genre. All
  mappings are saved to the Audio CD crosstables. A conversion is performed after
  installing and starting this version. You will not loose any data by doing this
  upgrade.
- Error while saving a child record (no impact).
- Exception on startup (no impact).
- Data Crow window is too large by default, causing it to go off screen in some
  situation (low resolution of the desktop and, for some reason, on the Mac OS X).
- The software module is duplicated; it is saved both in upper and lower case 
  (software.jar and Software.jar). Added a check for other modules as well.
- Loan panel / form now has the correct layout.
- In the table view edited tracks (child records) are not stored when pressing "save".
- Random hang of the application (changed invokeAndWait to invokeLater).
- Quick Filter toolbar and Filter Dialog show disabled fields.
- When an update causes the item to be put in a new node of the tree, this new node
  is not selected. Same thing when it is moved to another existing node in the tree.
- Audio Track module had lost its genres field. Re-added and removed the duplicated
  artists field.
- Line numbers are missing for error stack traces.
- Filtering on children does not work correctly (example: 'Audio Track Artists contains
  'Abba' would never return all Audio CD's with tracks from 'Abba').
- 'Undo grouping' from the grouping panel clears the grouping AND the view. After 
  performing a search the view is filled correctly. View should not be cleared.
- Double clicking on one of the items in the online search step of the item wizard
  adds the item to the 'new items' tab instead of continuing to the next step.
- Random unhandled exception: "java.lang.ArrayIndexOutOfBoundsException". This is due
  to removing and adding components in an not threadsafe way.
  (http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=4241014).
- In the view edited information is not correctly used by the item form (on saving).
  It shows the values correctly however on saving the old values are stored instead of 
  the new values.  
- Error when returning an item; status is not correctly updated in the view. A restart
  fixes this.
- Wrong regions are shown for the selected server for both the music file import and
  the Mass Update dialogs.
- Incorrect label for 'new item' menu item when templates are present.
- Error when updating a template. The template is saved, but the item form cannot be
  closed (NullPointer Exception). 

[New]
- File hash is stored to uniquely identify the file on the system. 
- New tool: Drive Manager. Manages drives on the system and makes sure Data Crow items
  containing file information remain up to date with the file system. (see the help
  for detailed information). Note that the selectable drives are depending on the 
  platform Data Crow is running on; in some cases only the "/" drive will be available.
- Alapage.com book search.
- Barnes & Nobles book search.
- Opening an item from the 'Media' module does not diplay the items pictures and shows
  an incorrect message 'there are unsaved changes' when closing the form.

[Changed]
- Modules now include a version number for upgrading purposes.
- Converted the current file size information (kilo bytes) to bytes.
- Added a sepecial file size field (showing the value in bytes).
- Add a property to modules: isFileBacked. When present, the system will add a filehash,
  filesize and a filename field to the module automatically. The module will also be
  used by the new Drive Manager functionality.


-----------------------------------------------------------------------------------------
Data Crow 3.1 [Release on 21/01/2008] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

This latest production version is a major overhaul of the internal system of Data Crow.
These will not be immediately apparent to the average user however it has caused 
noticeable positive side effects: increased startup performance, lower memory usage,
better performing views. 

Note: Java 1.4 and lower versions are no longer supported.


CHANGES SINCE LAST BETA (3.1 Beta 2):

[Fixed]
- Incorrect information shown when selecting the Discogs.com online server.
- Removing an item from the "new item" tab fails.
- The 'Delete Module Wizard' does not show any modules which can be deleted.
  The 'Delete Module Wizard' has been renamed to 'Delete Custom Module Wizard' and is
  only enabled when custom modules are available.
- Hang on startup (rare occurence).
- [1869780] Installer not working on Windows Vista. Created a Windows distribution. 
  (This is the normal installer, wrapped as an exe file using JSmooth).
- Help doesn't start.
- Unnecessary byte loading for images when opening item form.


CHANGES SINCE LAST PRODUCTION VERSION (3.0):

[New]
- New look and feel (JTattoo): http://www.jtattoo.net/
- Mac OS X look an feel (QuaQua):  https://quaqua.dev.java.net/
- Added 'Undo current Filter' action to the filter menu. (CTRL-X)
- [144128] Add image by URL. A picture can be added by entering an URL (see the file
  menu of the picture)
- New field available for the module designer: decimal field.
- Module delete wizard.

[Changed]
- Minimum Java version has been increased to 1.5. 
  As of this version 1.4 is no longer supported.
- Logging has been changed to Log4j. Not only is this more reliable and a proven 
  concept but it also allows easier integration with other products using Log4J.
- Added counts to the chart panel.
- Update All can now assign any kind of value. The dialog uses the same layout
  as an item form.
- Less restrictive field mapping for the migration tool; not all fields have to be
  mapped.
- Grouping panel: top most panel now holds all items instead of none.
- When restoring a backup you can now specify what you want to restore (modules,
  database, reports or all). 
  
  (Refactored)
- View (class) structure has been changed (*)
- Removed unneeded toString() calls.
- Changed value comparison code (used when checking if a save is needed).
- Removed unneeded clone() call from the item form (unnecessary object creation).
- Changed picture comparison in the item form (unneeded costly byte code comparison).
- Introduced Java generics to coding (Java 1.5+).
- Introduced annotations (Java 1.5+).
- Image object creation has been reduced by 50%. (Picture class change).
- Grouping pane is now shared among views for the same module; no waiting 
  time when switching between views, lower memory usage.
- Menu actions instances reduced from 1600 to 32; replaced specific menu action
  creation with a single generic menu action.
- Changed renderer object creation; limiting the amount of instances. 
- Replaced empty catch blocks. Improved logging/reporting of errors and warnings.
- Byte arrays are no longer used to render images. Picture class will only have a byte
  array assigned for newly assigned images. (reduced disk access & improved performance)
- Removed 3rd party code from the Data Crow library (datacrow.jar). 
  These are now provided as separate libraries.
- Updated ImageJ to use Swing instead of AWT components (needed for L&F compatibility).  
- Caching of string representation of the DcObject items for improved sorting performance.
- Packages structure renamed from 'net.sf.dc' to 'net.datacrow'.
- Antialiasing code has been moved from each individual class to the DcSwingUtilities class.
- Removed DcEditEventQueue; thread-lockup problems, unnecessary overhead, adds extra
  complexicity, exception hiding. Replaced with a specific mouse listener for specific
  component implementations.
- Removed inner action class; implementation shifted to parent.

[Fixed]
- [1851130] Asking for help in quick view settings breaks help system. 
- [1848040] Slow online search on non Windows platforms.
- [1846754] Limit of 10 hours and 59 minutes for playlength.
- [1864728] Report xsl fixes needed
- Expensive cleaner task made the application seem to 'hang' for several seconds.
- Very slow title rewriting on large data sets.
- Slow retrieval of images. A slight performance increase has been achieved.
- Mass update of audio cd's was not functioning. 
- Mass update of music albums was not functioning; artist was set to an invalid value. 
- Double loading of images on opening the item form.
- Memory leak in list view. List elements are now correctly removed from its parent; 
  the renderer held a reference even after the element had been removed from the list 
  (JList).
- Slow performing updates on the Grouping Panel. Speed increase; from as slow as 9000ms 
  to 300ms (for a tree made of 2000 nodes each containing on average 20 child nodes).
- ASIN field of both the software and movie module were of an incorrect type.
- Cell editing was not applied (but canceled) before saving in the table view.
- Multi reference fields cannot be selected for migration.
- Service URL and Service field not editable in the item form (correct) but editable in
  the table view (incorrect).
- Text export/report: incorrect tabulation.
- Text export/report: incorrect progress indication.
- String reader not closed (HTML panels).
- File resources not closed (settings).
- On startup; view is filled before the UI is shown. After the UI has been build
  the view is refilled. Removed the first; improved startup performance.
- Potential class cast exception in the wizards.
- After a restore the application hangs. The restore was successful however the UI
  was not updated correctly.
- Flickering of screen when selecting an item.
- [1846609] Datacrow on MAC 10.4.11 becomes unresponsive.
- Slow performance IMDB search using multiple windows.
- Slow overall performance of online search on Ubuntu.
- Possible error when starting Data Crow after using the module wizards. Modules
  were loaded in an incorrect sequence, causing a nullpointer. (low occurence)
- Incorrect columnname was possible for fields created using the module wizard 
  causing Data Crow to fail on startup. (low occurence)
- Data Crow fails to start after using the module wizard as the loan module was not
  yet present. (low occurence)

(*) View structures:

          Old view structure                    New view structure
     (complex and poor code re-use)     (clear structure, optimal code re-use)
     
                View                                 View
                /   \                           (IViewComponent*)
    TableBaseView   ListBaseView                       |
     (DcTable*)     (DcObjectList*)              CachedChildView
       /    \           /    \
    insert update    insert  update
     view   view      view    view
       |     
    cached
    childview
  
  * A view uses a view component to actually display its items. In the old
    situation a new view component type meant having to add at least 3 new classes
    to talk to this component. In the new situation only the view component itself
    has to be created, by implementing the IViewComponent interface. The, generic,
    View class can talk to any component implementing the IViewComponent interface.


-----------------------------------------------------------------------------------------
Data Crow 3.1.0 beta 2 [Release on 13/01/2008] [testing: moderate] [target: BETA]
-----------------------------------------------------------------------------------------
The first beta was compiled against the wrong Java version. It also contained one serious
bug which caused Data Crow to lockup after performing a second search.

[Fixed]
- Data Crow hangs on a second search. (introduced by beta 1)
- Data Crow does not run on Java 1.5. (introduced by beta 1)
- [1869780] 3.1 installation on Vista failed


-----------------------------------------------------------------------------------------
Data Crow 3.1.0 beta 1 [Release on 11/01/2008] [testing: moderate] [target: BETA]
-----------------------------------------------------------------------------------------
Recently there have been complaints of poor performance and lockups. As I am unable to
reproduce these kinds of errors, both on Windows Xp, 98 and Ubuntu 7.10, I urge people
having experienced these errors to help me test this beta release.

This release consist for the most parts of platform changes; new Java features
have been implemented, the internal view structure has undergone major changes and 
the old logging mechanism has been replaced with Log4j. 

Feature requests not yet implemented will be added to one of the next releases.

[Remarks]
  I have had several users asking me why the online search is slower compared to using
  a web browser and search yourself:
  
  Performance of IMDB search (and other online searched) is slower then when you would 
  go to the imdb website and search yourself. There are multiple reasons for this, the 
  most obvious is that Data Crow needs to transform the webpage into something that can
  be saved to the database. Another point is that Data Crow retrieves a larger image,
  a more detailed description, etc, from other locations. This takes more time.
  Other factors play a role as well; internet connection speed, firewall, virus scanner,
  etc. 

[New]
- New look and feel (JTattoo): http://www.jtattoo.net/
- Mac OS X look an feel (QuaQua):  https://quaqua.dev.java.net/ (not tested)
- Added 'Undo current Filter' action to the filter menu. (CTRL-X)
- [144128] Add image by URL. A picture can be added by entering an URL (see the file
  menu of the picture)
- New field available for the module designer: decimal field.
- Module delete wizard.

[Changed]
- Minimum Java version has been increased to 1.5. 
  As of this version 1.4 is no longer supported.
- Logging has been changed to Log4j. Not only is this more reliable and a proven 
  concept but it also allows easier integration with other products using Log4J.
- Added counts to the chart panel.
- Update All can now assign any kind of value. The dialog uses the same layout
  as an item form.
- Less restrictive field mapping for the migration tool; not all fields have to be
  mapped.
- Grouping panel: top most panel now holds all items instead of none.
- When restoring a backup you can now specify what you want to restore (modules,
  database, reports or all). 
  
  (Refactored)
- View (class) structure has been changed (*)
- Removed unneeded toString() calls.
- Changed value comparison code (used when checking if a save is needed).
- Removed unneeded clone() call from the item form (unnecessary object creation).
- Changed picture comparison in the item form (unneeded costly byte code comparison).
- Introduced Java generics to coding (Java 1.5+).
- Introduced annotations (Java 1.5+).
- Image object creation has been reduced by 50%. (Picture class change).
- Grouping pane is now shared among views for the same module; no waiting 
  time when switching between views, lower memory usage.
- Menu actions instances reduced from 1600 to 32; replaced specific menu action
  creation with a single generic menu action.
- Changed renderer object creation; limiting the amount of instances. 
- Replaced empty catch blocks. Improved logging/reporting of errors and warnings.
- Byte arrays are no longer used to render images. Picture class will only have a byte
  array assigned for newly assigned images. (reduced disk access & improved performance)
- Removed 3rd party code from the Data Crow library (datacrow.jar). 
  These are now provided as separate libraries.
- Updated ImageJ to use Swing instead of AWT components (needed for L&F compatibility).  
- Caching of string representation of the DcObject items for improved sorting performance.
- Packages structure renamed from 'net.sf.dc' to 'net.datacrow'.
- Antialiasing code has been moved from each individual class to the DcSwingUtilities class.
- Removed DcEditEventQueue; thread-lockup problems, unnecessary overhead, adds extra
  complexicity, exception hiding. Replaced with a specific mouse listener for specific
  component implementations.
- Removed inner action class; implementation shifted to parent.

[Fixed]
- [1851130] Asking for help in quick view settings breaks help system. 
- [1848040] Slow online search on non Windows platforms.
- [1846754] Limit of 10 hours and 59 minutes for playlength.
- [1864728] Report xsl fixes needed
- Expensive cleaner task made the application seem to 'hang' for several seconds.
- Very slow title rewriting on large data sets.
- Slow retrieval of images. A slight performance increase has been achieved.
- Mass update of audio cd's was not functioning. 
- Mass update of music albums was not functioning; artist was set to an invalid value. 
- Double loading of images on opening the item form.
- Memory leak in list view. List elements are now correctly removed from its parent; 
  the renderer held a reference even after the element had been removed from the list 
  (JList).
- Slow performing updates on the Grouping Panel. Speed increase; from as slow as 9000ms 
  to 300ms (for a tree made of 2000 nodes each containing on average 20 child nodes).
- ASIN field of both the software and movie module were of an incorrect type.
- Cell editing was not applied (but canceled) before saving in the table view.
- Multi reference fields cannot be selected for migration.
- Service URL and Service field not editable in the item form (correct) but editable in
  the table view (incorrect).
- Text export/report: incorrect tabulation.
- Text export/report: incorrect progress indication.
- String reader not closed (HTML panels).
- File resources not closed (settings).
- On startup; view is filled before the UI is shown. After the UI has been build
  the view is refilled. Removed the first; improved startup performance.
- Potential class cast exception in the wizards.
- After a restore the application hangs. The restore was successful however the UI
  was not updated correctly.
- Flickering of screen when selecting an item.

  (Unconfirmed)
- [1846609] Datacrow on MAC 10.4.11 becomes unresponsive.
- Slow performance IMDB search using multiple windows.
- Slow overall performance of online search on Ubuntu.

(*) View structures:

        Old view structure                    New view structure
     (complex and poor code re-use)     (clear structure, optimal code re-use)
     
                View                              View
                /   \                        (IViewComponent*)
    TableBaseView   ListBaseView                    |
     (DcTable*)     (DcObjectList*)           CachedChildView
       /    \           /    \
    insert update    insert  update
     view   view      view    view
       |     
    cached
    childview
  
  * A view uses a view component to actually display its items. In the old
    situation a new view component type meant having to add at least 3 new classes
    to talk to this component. In the new situation only the view component itself
    has to be created, by implementing the IViewComponent interface. The, generic,
    View class can talk to any component implementing the IViewComponent interface.

-----------------------------------------------------------------------------------------
Data Crow 3.0.0 [Release on 02/11/2007] [testing: high] [target: production]
-----------------------------------------------------------------------------------------

This is the end result of the developments for Data Crow 3 which started at the end of
June this year. To summarize this release contains the module creation functionality,
advanced filtering, image editing using ImageJ and persons and companies such as actors
and publishers now reside in their own, fully functional, modules.

! Upgrading: please upgrade to 2.9.5 or higher before upgrading to this version.
  All Data Crow 3 alpha version and beta versions can safely upgrade to this version
  
! Make a backup before upgrading to this version.

[License Change]
  The License for this software has changed from LGPL (GNU Lesser General Public License)
  to GPL (GNU General Public License). For more information on the GPL license I refer you
  to the following website: http://www.gnu.org/licenses/gpl.html. As a normal user of 
  Data Crow this will not effect you in any way.

[Fixed]
- 'Update all' clears values which should not be cleared.
- Chart does not work for genres; selecting genres and pressing the button does not generate
  the chart. No message is shown.
- The user is not informed when a chart cannot be created.
- Data Crow allows users to exit without warning about unsaved changes.
- [1820972] Filename cleared when pressing cancel on browse
- Searching for empty (category) from quick filter does not retrieve empty values.
- Image quality of the module icons reduced after making changes to the module.
- Content of comboboxes not anti-aliased.
- Online search does not add tracks to existing items (item form > update).
- Grouping is case-sensitive.
- Slow building of the grouping pane.
- Text partially hidden by the scrollbar in the quick view pane.
- Data Crow does not start after creating a reference field. Incorrect module references 
  can no longer be created.
- Low quality icons for actors, directors, ..

[Changed]
- The criteria for fields on which can be grouped has been altered.
- The fields in the dropdown from the grouping pane is now shown ordered alphabetically.
- Field type names in the 'define field' dialog have been changed.
- For item forms the icon of the selected item type (module) is shown instead of the
  default Data Crow icon.


-----------------------------------------------------------------------------------------
Below follows a compilation of all the changes and additions done after the 2.12 version.
-----------------------------------------------------------------------------------------

[New]
- [1767488] Statistics. The note-tab has been replaced by a 'Chart Tab'
- [1782401] Massive Import of e-books. A simple e-book file importer has been created
- [1767490] Add file info after a record was created
- Plugable module support. Modules are packed as jar files and placed in the modules 
  folder.
- A new menu can be found in the menu bar called 'modules'. This new menu contains 
  the wizards for creating, modifying and relating modules.
- Users can defined advanced new modules using the new "create module wizard"
- Users can alter existing modules (extend with fields or remove fields)
- Users can relate modules to create parent child relationships between their newly 
  created
  modules (audio CD <> tracks)
- Added a settings panel for the quick view. This allows you to set the field order, 
  the shown fields and there direction.
- Programmers can easily add additional functionality to new modules (online search, 
  synchronizers, import, ..) 
- Implementation of module upgrade while respecting changes made by the user
- Help is now also available from the help directory of Data Crow (/help).
- Added Bol.com as a Dutch book online service.
- Added discogs.com as a audio CD / music album online service.
- Pictures can now be saved to a file from the picture menu.
  Attaching file information to an existing item. If you have registered a movie,
  music file, image, etc, you can easily attach the file information.
- Image editor. Data Crow has integrated ImageJ. A very successful and reliable
  project; check it out at http://rsb.info.nih.gov/ij/
- Online Artists search (MusicBrainz). 
- Detailed information on developers and publishers is retrieved.
 
[Changed]
- [1751690] Store update source per record. Selected server, search mode and region are 
  now stored in the database per record. 
- [1758367] Use of Enter, Esc- & Del-Hotkeys. Escape now closes the form / dialog.
  Delete removes items in views.
- [1773009] Template Rating change. You can now define which values (fields) should be 
  retrieved when searching online for new items.
- [1777293] Add RGB fields for color picker. 
  New color chooser in the settings dialog (default Java color chooser).
- [1782398] Can't update the cover of an album with web services.
- [1767489] Actors/actresses/etc links
- [1751690] Store update source per record
- Modules are defined in XML instead of being hard coded
- Additional field setting: descriptive y/n. This settings overrules the default 
  way an item is described (such as in the list view).
- Support for Java 1.4. Multiple persons indicated they could not use Data Crow because
  of the missing Java 1.4 support.  
- Movie module: actors and directors are now items instead of text values
- Audio CD module: artists are items instead of text values
- Audio Track module: artists are items instead of text values
- Music Album module: artists are items instead of text values
- Music Track module: artists are items instead of text values
- Book module: authors and publishers are items instead of text values
- Software module: developers and publishers are items instead of text values
- Reference field & multiple reference field now allow references to other modules
  beside the properties.
- Improved the design and functioning of the 'references' editor
- Imdb actor / director search
- Renewed filter dialog. The old one has been discarded and replaced with a clean
  looking and intuitive dialog.
- Filter conditions such as 'contains', 'less then', 'is filled', 'less then', etc.
- Sorting dialog has been changed / updated. Allows multiple levels of sorting (more
  then 2).
- The parameters for data crow have changed:
  to specify a different database: -db:<name>
  to indicate the installation directory (fix for bug): -dir:<directory> (spaces allowed)
- FreeDB support has been canceled. The discid reading is unstable and can no longer be 
  supported. The addition of discogs (new) and musicbrainz should soften the pain.
- Filter dialog: changed the multi-reference field to a normal drop-down / combo box.
- Filter dialog: allow multiple conditions per field.
- Cleaner implementation of most online search task classes.
- Text report (export) now mentions the picture filename instead of 'Yes' or 'No'.
- Smaller legend for the chart panel.
  Music Album now also benefits from the online search functionality.
- Added module metadata upgrade functionality.
- Package structure has completely changed for most of the code tree.
- Improved the technical implementation of the importers 
  (allow single files to be parsed).
- Logger has been rewritten (DcLog instead of DcMessages and DcMessagesWriter). 
- More flexible implementation of the implementation classes (importers, online search, 
  synchronizers).
- Selected server, search mode and region are correctly remembered. In the old
  situation only the server name was remembered for a next run.
- When updating an record (online search) the stored server, region and mode are 
  pre-selected.
- Integer definitions have changed to long values.
- The image fields in the item form are now easily edited & deleted. It also gained a 
  lot of new functionality (see the new section).
- Improved the online search for updating existing items. The actual link
  from which the item was found (if applicable) is stored and used to re-parse
  the item. 
- Selected field in the quick filter bar is remembered.
- Added 'does not contains' operator for filtering.
- When pressing "edit" to edit a saved filter the corresponding tab is opened.
- A double-click on an image field now either opens the browse dialog (when no
  image has been defined as yet) or the new edit dialog (ImageJ) for existing
  images.
- Refactoring of the online search. The implementation was scattered over 
  several classes and packages. The functionality is now structured to make
  it maintainable and easier to expand.
- The URL field has gained launch button.
- The database layer implementation has changed. To comply with future plans, the
  SQL is created using the prepared statements provide by Java.
- Renamed 'Program Definitions' to 'File Associations' in the settings menu
- Lowered the amount of I/O (disk) operations when dealing with images in views.
- Removed the "save current" button from the settings view.
- When searching for new items online you can now specify which values should be
  retrieved.
- Persons and companies are now "associates" instead of (all) "persons".
- Changed the name of the "odd row color" and "even row color" to "odd color" and
  "even color".
- Card view uses the even and odd color
- The date field has gained a date picker (calendar).
- In the wizard the button "finish & restart" has been renamed to "finish & new" as
  this was confusing for most users in case of the module wizard(s).
- Minor modules (actors and such) are no longer available from the modules menu in
  the menu bar.
- For the online search a new option has been introduced to also search online for
  items like actors, developers, etc. This option is turned off by default as the
  decrease in speed is significant. However when turned on, more detailed information
  is retrieved, such as a description and a photo. Existing items are of course re-used
  (as in the old situation). Turning this off will just create the item (if it does not
  exist yet) having only the name filled in. You can use the mass update or the online 
  update later on on these items.
- Books have gained new fields: storage medium (for e-books) and file size .
- 'Generic Objects' module has its name changed to 'Media'
- Improved Amazon search
- Sub-items like categories and authors are now only added to the database if the item
  to which these belong is saved. This prevents polution of the database after doing 
  an online search.
- Reports have been polished (a little). 
- It is now possible to point a report to a stylesheet from the properties file. 
  This stylesheet is copied to the directory of the generated report. For now this is
  used for the HTML reports. The stylesheets themselves can be found in 
  "/report/_stylesheets".  
- The logo has been updated / altered as well as the program icons.  
